// To compile: 
// csc Listing1_1cs.cs

using System;
using System.Reflection;

class UsingReflection
{
  public static void Main(String [] args)
  {
    if (args.Length < 1)
    {
      Console.WriteLine("You must specify an assembly name.");
      return;
    }

    Assembly a = null;

    try
    {
      // Load the assembly from a filename
      a = Assembly.LoadFrom(args[0]);
      Console.WriteLine("Assembly: " + a.GetName());
    }
    catch (Exception e)
    {
      Console.WriteLine ("Could not load the assembly: " + e.Message);
      return;
    }

    // Enumerate over the types in the assembly
    foreach (Type t in a.GetTypes())
    {
      try
      {
        Console.Write("Attempting to create " + t.FullName + "...");

       // Create an instance.  
       // This fails if there's no public default constructor.
       object o = Activator.CreateInstance(t);

        Console.WriteLine(" Succeeded.");

       // Enumerate over the methods in the type
       foreach (MethodInfo method in t.GetMethods())
        {
         // Look for methods with no parameters
         if (method.GetParameters().Length == 0)
          {
            Console.Write("Invoking " + method.Name + "...");
           object returnValue = method.Invoke(o, null);
            Console.WriteLine(" Succeeded and returned " + returnValue);
          }
        }
      }
      catch (Exception e)
      {
        Console.WriteLine(" Failed (" + e.GetType().ToString() + ").");
      }
    }
  }
}