' To compile: 
' vbc Listing1_1vb.vb

Imports System
Imports System.Reflection

Class UsingReflection
   
  Public Shared Sub Main()
  
    Dim args() As String = Environment.GetCommandLineArgs()

    If args.Length < 2 Then
      Console.WriteLine("You must specify an assembly name.")
      Exit Sub
    End If
      
    Dim a As [Assembly] = Nothing
      
    Try
      ' Load the assembly from a filename
      a = [Assembly].LoadFrom(args(1))
      Console.WriteLine("Assembly: " & a.GetName().ToString())
    Catch e As Exception
      Console.WriteLine("Could not load the assembly: " & e.Message)
      Exit Sub
    End Try
      
    ' Enumerate over the types in the assembly
    Dim t As Type
    For Each t In a.GetTypes()
      Try
        Console.Write("Attempting to create " & t.FullName & "...")
            
        ' Create an instance.  
        ' This fails if there's no public default constructor.
        Dim o As Object = Activator.CreateInstance(t)
            
        Console.WriteLine(" Succeeded.")
            
        ' Enumerate over the methods in the type
        Dim method As MethodInfo
        For Each method In t.GetMethods()
          ' Look for methods with no parameters
          If method.GetParameters().Length = 0 Then
            Console.Write("Invoking " & method.Name & "...")
            Dim returnValue As Object = method.Invoke(o, Nothing)
            Console.WriteLine(" Succeeded and returned " & returnValue)
          End If
        Next method
      Catch e As Exception
        Console.WriteLine(" Failed (" & e.GetType().ToString() & ").")
      End Try
    Next t
   End Sub
End Class