// To compile by itself:
// csc /t:library Listing1_2cs.cs
// Otherwise, use this with Listing 1.3

using System;

[AttributeUsage(AttributeTargets.All, AllowMultiple=true)]
public class KeywordAttribute : Attribute
{
  private string keyword;
  private int relevance;

  // Constructor - called when the attribute is applied
  public KeywordAttribute(string word)
  {
    this.keyword = word;
    this.relevance = 5;
  }

  // Read-only property to get the keyword
  public virtual string Keyword
  {
    get { return keyword; }
  }

  // Property to get/set the relevance
  public virtual int Relevance
  {
    get { return relevance; }
    set { relevance = value; }
  }
}