' To compile by itself:
' vbc /t:library Listing1_2vb.vb
' Otherwise, use this with Listing 1.3

Imports System

<AttributeUsage(AttributeTargets.All, AllowMultiple:=True)> _
Public Class KeywordAttribute
  Inherits Attribute
  Private _keyword As String
  Private _relevance As Integer
  
  ' Constructor - called when the attribute is applied
  Public Sub New(word As String)
    _keyword = word
    _relevance = 5
  End Sub
   
  ' Read-only property to get the keyword
  Public Overridable ReadOnly Property Keyword() As String
    Get
      Return _keyword
    End Get
  End Property 

  ' Property to get/set the relevance
  Public Overridable Property Relevance() As Integer
    Get
      Return _relevance
    End Get
    Set
      _relevance = value
    End Set
  End Property
End Class