' To compile:
' vbc Listing1_3vb.vb Listing1_2vb.vb IApplication.vb
' For demonstration, you can run this program on itself since it contains the IApplication interface:
' Listing1_3vb.exe Listing1_3vb.exe

Imports System
Imports System.Reflection

Class UsingReflection

  Public Shared Sub Main()
  
    Dim args() As String = Environment.GetCommandLineArgs()

    If args.Length < 2 Then
      Console.WriteLine("You must specify an assembly name.")
      Exit Sub
    End If
         
    Dim a As [Assembly] = Nothing
      
    Try
      ' Load the assembly from a filename
      a = [Assembly].LoadFrom(args(0))
      Console.WriteLine("Assembly " & a.GetName().ToString())
    Catch e As Exception
      Console.WriteLine("Could not load the assembly: " + e.Message)
      Exit Sub
    End Try
      
    ' Enumerate over the types in the assembly
    Dim t As Type
    For Each t In a.GetTypes()
      Try
        Dim attributes() As KeywordAttribute
            
        ' Check for the KeywordAttribute on the type
        attributes = CType(t.GetCustomAttributes(GetType(KeywordAttribute), True), KeywordAttribute())
            
        PrintKeywords(t.ToString(), attributes)
            
        ' Enumerate over the members in the type
        Dim member As MemberInfo
        For Each member In t.GetMembers()
          ' Check for the KeywordAttribute on the member
          attributes = CType(member.GetCustomAttributes(GetType(KeywordAttribute), True), KeywordAttribute())
 
          PrintKeywords(t.ToString() & "." & member.Name, attributes)
        Next member
      Catch e As Exception
        Console.WriteLine(" Failed (" & e.GetType().ToString() & ").")
      End Try
    Next t
  End Sub

  Public Shared Sub PrintKeywords(element As String, attributes() As KeywordAttribute)
    Console.WriteLine(">> " & element)
      
    Dim a As KeywordAttribute
    For Each a In attributes
      Console.WriteLine("   keyword = " & a.Keyword & " (" & a.Relevance & ")")
    Next a
  End Sub
End Class