// To compile:
// csc /t:library Listing1_4.cs ExampleAttribute.cs

// Attribute on assembly, placed at the top of a source file
[assembly:Example]
// Attribute on module, placed at the top of a source file     
[module:Example]     

[Example] // Attribute on class
public class Class1
{
  [Example] // Attribute on constructor
  public Class1() { }

  [Example] // Attribute on method
  public void MyMethod1([Example] int i) { } // Attribute on parameter

  [return:Example] // Attribute on return value
  public int MyMethod2() { return 0; }

  [Example] // Attribute on property
  public string MyProperty
  {
    [return:Example] // Attribute on return value for accessor method
    get { return ""; }
    [param:Example] // Attribute on parameter for accessor method
    set { }
  }
}

[Example] // Attribute on struct
public struct MyStruct
{
  [Example] // Attribute on field
  public int MyField;
}

[Example] // Attribute on delegate
public delegate int MyDelegate1();

[return:Example] // Attribute on delegate's return value
public delegate int MyDelegate2();

[Example] // Attribute on enum
public enum MyEnum
{
  One,
  Two
}

[Example, Example, Example] // Multiple attributes on interface
public interface MyInterface
{
  [Example] // Attribute on event
  event MyDelegate1 MyEvent;
}