// To compile:
// cl /LD /CLR ExampleAttribute.cpp /FeChapter1.dll
// 
#using <mscorlib.dll>
// Assembly containing definition of ExampleAttribute
#using <Chapter1.dll>   
// Shortcut to avoid typing System::String
using namespace System; 
// Attribute on assembly, placed at the top of a source file
[assembly:Example];   
// Attribute on module, placed at the top of a source file
[module:Example];     

[Example] // Attribute on class
public __gc class Class1
{
  public:

  [Example] // Attribute on constructor
  Class1() { }

  [Example] // Attribute on method
  void MyMethod1([Example] String* s) { } // Attribute on parameter

  [returnvalue:Example] // Attribute on return value
  int MyMethod2() { return 0; }

  [returnvalue:Example] // Attribute on return value for accessor method
  __property String* get_MyProperty() { return ""; }
  // Attribute on parameter for accessor method
  __property void set_MyProperty([Example] String* s) { }
};

[Example] // Attribute on struct
public __gc struct MyStruct
{
  [Example] // Attribute on field
  int MyField;
};

[Example] // Attribute on delegate
public __delegate int MyDelegate1();

[returnvalue:Example] // Attribute on delegate's return value
public __delegate int MyDelegate2();

[Example] // Attribute on enum
public __value enum MyEnum
{
  One,
  Two
};

[Example, Example, Example] // Multiple attributes on interface
public __gc __interface MyInterface
{
  [Example] // Attribute on event
  __event MyDelegate1* MyEvent;
};