// Simple Web Browser - see Chapter 5 for a more complete browser that uses events.
// Before compiling, run AXIMP on shdocvw.dll to create AxSHDocVw.dll and SHDocVw.dll.  Then run:
// csc MyWebBrowser.cs /r:System.Windows.Forms.dll /r:System.Drawing.dll /r:System.dll /r:SHDocVw.dll /r:AxSHDocVw.dll /res:MyWebBrowser.resources

using System;
using SHDocVw;
using System.Windows.Forms;
using System.Reflection;

public class MyWebBrowser : Form
{
  private System.ComponentModel.IContainer components;
  private System.Windows.Forms.StatusBar statusBar1;
  private System.Windows.Forms.ToolBar toolBar1;
  private System.Windows.Forms.ToolBarButton backButton;
  private System.Windows.Forms.ToolBarButton forwardButton;
  private System.Windows.Forms.ToolBarButton stopButton;
  private System.Windows.Forms.Panel panel1;
  private AxSHDocVw.AxWebBrowser axWebBrowser1;
  private System.Windows.Forms.Button goButton;
  private System.Windows.Forms.TextBox navigateBox;
  private System.Windows.Forms.ImageList imageList1;
  private System.Windows.Forms.ToolBarButton refreshButton;
  private System.Windows.Forms.ToolBarButton homeButton;
  private System.Windows.Forms.Label label1;

  object m = Type.Missing;

  public MyWebBrowser()
  {
    // Required for Windows Form Designer support
    InitializeComponent();
    axWebBrowser1.GoHome();
  }
  
  // Clean up any resources being used
  protected override void Dispose( bool disposing )
  {
    if (disposing)
    {
      if (components != null) 
      {
        components.Dispose();
      }
    }
    base.Dispose(disposing);
  }

  // Required method for Designer support
  private void InitializeComponent()
  {
    this.components = new System.ComponentModel.Container();
    System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MyWebBrowser));
    this.statusBar1 = new System.Windows.Forms.StatusBar();
    this.toolBar1 = new System.Windows.Forms.ToolBar();
    this.backButton = new System.Windows.Forms.ToolBarButton();
    this.forwardButton = new System.Windows.Forms.ToolBarButton();
    this.stopButton = new System.Windows.Forms.ToolBarButton();
    this.refreshButton = new System.Windows.Forms.ToolBarButton();
    this.homeButton = new System.Windows.Forms.ToolBarButton();
    this.imageList1 = new System.Windows.Forms.ImageList(this.components);
    this.goButton = new System.Windows.Forms.Button();
    this.panel1 = new System.Windows.Forms.Panel();
    this.axWebBrowser1 = new AxSHDocVw.AxWebBrowser();
    this.navigateBox = new System.Windows.Forms.TextBox();
    this.label1 = new System.Windows.Forms.Label();
    this.panel1.SuspendLayout();
    ((System.ComponentModel.ISupportInitialize)(this.axWebBrowser1)).BeginInit();
    this.SuspendLayout();
    // 
    // statusBar1
    // 
    this.statusBar1.Location = new System.Drawing.Point(0, 437);
    this.statusBar1.Name = "statusBar1";
    this.statusBar1.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
    this.statusBar1.Size = new System.Drawing.Size(528, 16);
    this.statusBar1.TabIndex = 2;
    // 
    // toolBar1
    // 
    this.toolBar1.AutoSize = false;
    this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] { this.backButton, this.forwardButton, this.stopButton, this.refreshButton, this.homeButton});
    this.toolBar1.ButtonSize = new System.Drawing.Size(80, 23);
    this.toolBar1.Divider = false;
    this.toolBar1.DropDownArrows = true;
    this.toolBar1.ImageList = this.imageList1;
    this.toolBar1.Name = "toolBar1";
    this.toolBar1.ShowToolTips = true;
    this.toolBar1.Size = new System.Drawing.Size(528, 28);
    this.toolBar1.TabIndex = 3;
    this.toolBar1.TextAlign = System.Windows.Forms.ToolBarTextAlign.Right;
    this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
    // 
    // backButton
    // 
    this.backButton.ImageIndex = 0;
    this.backButton.Text = "Back";
    // 
    // forwardButton
    // 
    this.forwardButton.ImageIndex = 1;
    this.forwardButton.Text = "Forward";
    // 
    // stopButton
    // 
    this.stopButton.ImageIndex = 2;
    this.stopButton.Text = "Stop";
    // 
    // refreshButton
    // 
    this.refreshButton.ImageIndex = 3;
    this.refreshButton.Text = "Refresh";
    // 
    // homeButton
    // 
    this.homeButton.ImageIndex = 4;
    this.homeButton.Text = "Home";
    // 
    // imageList1
    // 
    this.imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
    this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
    this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
    this.imageList1.TransparentColor = System.Drawing.Color.Magenta;
    // 
    // goButton
    // 
    this.goButton.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
    this.goButton.Location = new System.Drawing.Point(469, 32);
    this.goButton.Name = "goButton";
    this.goButton.Size = new System.Drawing.Size(56, 20);
    this.goButton.TabIndex = 6;
    this.goButton.Text = "Go";
    this.goButton.Click += new System.EventHandler(this.goButton_Click);
    // 
    // panel1
    // 
    this.panel1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
      | System.Windows.Forms.AnchorStyles.Left) 
      | System.Windows.Forms.AnchorStyles.Right);
    this.panel1.Controls.AddRange(new System.Windows.Forms.Control[] {this.axWebBrowser1});
    this.panel1.Location = new System.Drawing.Point(0, 58);
    this.panel1.Name = "panel1";
    this.panel1.Size = new System.Drawing.Size(528, 382);
    this.panel1.TabIndex = 9;
    // 
    // axWebBrowser1
    // 
    this.axWebBrowser1.ContainingControl = this;
    this.axWebBrowser1.Dock = System.Windows.Forms.DockStyle.Fill;
    this.axWebBrowser1.Enabled = true;
    this.axWebBrowser1.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("axWebBrowser1.OcxState")));
    this.axWebBrowser1.Size = new System.Drawing.Size(528, 382);
    this.axWebBrowser1.TabIndex = 0;
    // 
    // navigateBox
    // 
    this.navigateBox.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
      | System.Windows.Forms.AnchorStyles.Right);
    this.navigateBox.Location = new System.Drawing.Point(56, 32);
    this.navigateBox.Name = "navigateBox";
    this.navigateBox.Size = new System.Drawing.Size(408, 20);
    this.navigateBox.TabIndex = 12;
    this.navigateBox.Text = "";
    // 
    // label1
    // 
    this.label1.Location = new System.Drawing.Point(8, 35);
    this.label1.Name = "label1";
    this.label1.Size = new System.Drawing.Size(48, 16);
    this.label1.TabIndex = 13;
    this.label1.Text = "Address";
    // 
    // MyWebBrowser
    // 
    this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
    this.ClientSize = new System.Drawing.Size(528, 453);
    this.Controls.AddRange(new System.Windows.Forms.Control[] {this.label1, this.toolBar1, this.navigateBox, this.panel1, this.goButton, this.statusBar1});
    this.Name = "MyWebBrowser";
    this.Text = "Web Browser";
    this.panel1.ResumeLayout(false);
    ((System.ComponentModel.ISupportInitialize)(this.axWebBrowser1)).EndInit();
    this.ResumeLayout(false);
  }

  [STAThread]
  static void Main() 
  {
    Application.Run(new MyWebBrowser());
  }

  // Called when one of the toolbar buttons is clicked
  private void toolBar1_ButtonClick(object sender, ToolBarButtonClickEventArgs e)
  {
    if (e.Button.Text == "Back")
    {
      try { axWebBrowser1.GoBack(); }
      catch {}
    }
    else if (e.Button.Text == "Forward")
    {
      try { axWebBrowser1.GoForward(); }
      catch {}
    }
    else if (e.Button.Text == "Stop")
    {
      axWebBrowser1.Stop();
    }
    else if (e.Button.Text == "Refresh")
    {
      axWebBrowser1.CtlRefresh();
    }
    else if (e.Button.Text == "Home")
    {
      axWebBrowser1.GoHome();
    }
  }

  // Called when "Go" is clicked
  private void goButton_Click(object sender, System.EventArgs e)
  {
    axWebBrowser1.Navigate(navigateBox.Text, ref m, ref m, ref m, ref m);
  }
}