// To compile:
// csc Listing5_10cs.cs /r:SHDocVw.dll /r:Microsoft.mshtml.dll
// (Microsoft.mshtml.dll should be the PIA)

using System;
using SHDocVw;
using mshtml;

public class WebBrowserHost
{
  private InternetExplorer ie;

  public WebBrowserHost()
  {
    ie = new InternetExplorer();

    // Hook up event handlers to the events we care about
    ie.DocumentComplete += new 
      DWebBrowserEvents2_DocumentCompleteEventHandler(DocumentComplete);
    ie.ProgressChange += new 
      DWebBrowserEvents2_ProgressChangeEventHandler(ProgressChange);
    ie.TitleChange += new 
      DWebBrowserEvents2_TitleChangeEventHandler(TitleChange);

    // Events corresponding to the non-default source interface:
    ((DWebBrowserEvents_Event)ie).WindowResize += new
      DWebBrowserEvents_WindowResizeEventHandler(WindowResize);
    ((DWebBrowserEvents_Event)ie).Quit += new
      DWebBrowserEvents_QuitEventHandler(Quit);

    // Show the browser
    ie.Visible = true;
    ie.GoHome();
  }

  public void Document_MouseOver()
  {
    Console.WriteLine("MouseOver");
  }

  public bool Document_Click(IHTMLEventObj pEvtObj)
  {
    Console.WriteLine("Click: " + pEvtObj.x + ", " + pEvtObj.y);
    return true;
  }

  public void DocumentComplete(object pDisp, ref object URL)
  {
    Console.WriteLine("DocumentComplete");

    ((HTMLDocumentEvents_Event)ie.Document).onmouseover += new
      HTMLDocumentEvents_onmouseoverEventHandler(Document_MouseOver);
    ((HTMLDocumentEvents2_Event)ie.Document).onclick += new 
      HTMLDocumentEvents2_onclickEventHandler(Document_Click);
  }

  public void ProgressChange(int Progress, int ProgressMax)
  {
    Console.WriteLine("ProgressChange: " + Progress +
      " out of " + ProgressMax);
  }

  public void TitleChange(string Text)
  {
    Console.WriteLine("TitleChange: " + Text);
  }

  public void WindowResize()
  {
    Console.WriteLine("WindowResize");
  }

  public void Quit(ref bool Cancel)
  {
    Console.WriteLine("Quit");
    Environment.Exit(0);
  }

  public static void Main()
  {
    WebBrowserHost listener = new WebBrowserHost();

    // Keep the program running while Internet Explorer is open
    Console.WriteLine("*** Press Enter to quit ***");
    Console.Read();
  }
}