' To compile:
' vbc Listing5_10vb.vb /r:SHDocVw.dll /r:Microsoft.mshtml.dll
' (Microsoft.mshtml.dll should be the PIA)

Imports System
Imports SHDocVw
Imports mshtml

Public Class WebBrowserHost

  Private ie As InternetExplorer

  Public Sub New()
    ie = new InternetExplorer()

    ' Hook up event handlers to the events we care about
    AddHandler ie.DocumentComplete, AddressOf DocumentComplete
    AddHandler ie.ProgressChange, AddressOf ProgressChange
    AddHandler ie.TitleChange, AddressOf TitleChange

    ' Events corresponding to the non-default source interface:
    AddHandler CType(ie, DWebBrowserEvents_Event).WindowResize, AddressOf WindowResize
    AddHandler CType(ie, DWebBrowserEvents_Event).Quit, AddressOf Quit

    ' Show the browser
    ie.Visible = true
    ie.GoHome()
  End Sub

  Public Sub Document_MouseOver()
    Console.WriteLine("MouseOver")
  End Sub

  Public Sub Document_Click(pEvtObj As IHTMLEventObj)
    Console.WriteLine("Click: " & pEvtObj.x & ", " & pEvtObj.y)
  End Sub

  Public Sub DocumentComplete(pDisp As Object, ByRef URL As Object)
    Console.WriteLine("DocumentComplete")

    AddHandler CType(ie.Document, HTMLDocumentEvents_Event).onmouseover, AddressOf Document_MouseOver
    AddHandler CType(ie.Document, HTMLDocumentEvents2_Event).onmouseover, AddressOf Document_Click
  End Sub

  Public Sub ProgressChange(Progress As Integer, ProgressMax As Integer)
    Console.WriteLine("ProgressChange: " & Progress & " out of " & ProgressMax)
  End Sub

  Public Sub TitleChange(Text As String)
    Console.WriteLine("TitleChange: " & Text)
  End Sub

  Public Sub WindowResize()
    Console.WriteLine("WindowResize")
  End Sub

  Public Sub Quit(ByRef Cancel As Boolean)
    Console.WriteLine("Quit")
    Environment.Exit(0)
  End Sub

  <MTAThread> _
  Public Shared Sub Main()
    Dim listener As WebBrowserHost = new WebBrowserHost()

    ' Keep the program running while Internet Explorer is open
    Console.WriteLine("*** Press Enter to quit ***")
    Console.Read()
  End Sub

End Class