// To compile:
// csc Listing5_1cs.cs

using System;

public interface IChatRoomDisplay
{
  void DisplayMessage(string text);
  void UserJoined(string user);
  void UserLeft(string user);
}

public class ConsoleDisplay : IChatRoomDisplay
{
  public void DisplayMessage(string text) 
  {
    Console.WriteLine("MESSAGE: " + text);
  }
 
  public void UserJoined(string user) 
  {
    Console.WriteLine("JOINED: " + user);
  }

  public void UserLeft(string user) 
  {
    Console.WriteLine("LEFT: " + user);
  }
}

public class ChatRoomClient
{   
  public static void Main() 
  {
    IChatRoomDisplay display = new ConsoleDisplay();
    ChatRoomServer server = new ChatRoomServer();
    //...
    server.Run(display);
    //...
  }
}

public class ChatRoomServer
{
  public void Run(IChatRoomDisplay display)
  {
    //...
    // The callback
    if (display != null) display.DisplayMessage("text");
    //...
  }
}