' To compile:
' vbc Listing5_1vb.vb

Imports System

Public Interface IChatRoomDisplay
  Sub DisplayMessage(text As String)
  Sub UserJoined(user As String)
  Sub UserLeft(user As String)
End Interface

Public Class ConsoleDisplay
  Implements IChatRoomDisplay
 
  Public Sub DisplayMessage(text As String) Implements IChatRoomDisplay.DisplayMessage
    Console.WriteLine("MESSAGE: " & text)
  End Sub

  Public Sub UserJoined(user As String) Implements IChatRoomDisplay.UserJoined
    Console.WriteLine("JOINED: " & user)
  End Sub

  Public Sub UserLeft(user As String) Implements IChatRoomDisplay.UserLeft
    Console.WriteLine("LEFT: " & user)
  End Sub
End Class

Public Class ChatRoomClient
  Public Shared Sub Main()
    Dim display = New ConsoleDisplay()
    Dim server As New ChatRoomServer()
    '...
    server.Run(display)
    '...
  End Sub
End Class

Public Class ChatRoomServer
  Public Sub Run(display As IChatRoomDisplay)
    '...
    ' The callback
    If Not (display Is Nothing) Then
      display.DisplayMessage("text")
    End If 
    '...
  End Sub
End Class