// To compile:
// csc Listing5_2.cs /r:System.Windows.Forms.dll

using System;

// The delegates
public delegate void DisplayMessage(string text);
public delegate void UserJoined(string user);
public delegate void UserLeft(string user);

public class Display
{
  public void ConsoleMessage(string text) 
  {
    Console.WriteLine("MESSAGE: " + text);
  }
 
  public void AnnoyingMessage(string text) 
  {
    System.Windows.Forms.MessageBox.Show("MESSAGE: " + text);
  }
}

public class ChatRoomClient
{   
  public static void Main() 
  {
    Display display = new Display();
    ChatRoomServer server = new ChatRoomServer();
    DisplayMessage one = new DisplayMessage(display.ConsoleMessage);
    DisplayMessage two = new DisplayMessage(display.AnnoyingMessage);
    DisplayMessage both = one + two;
    //...
    server.Run(both);
    //...
  }
}

public class ChatRoomServer
{
  public void Run(DisplayMessage display)
  {
    //...
    // The callback
    if (display != null) display("text");
    //...
  }
}