// To compile:
// csc Listing5_4.cs /r:System.Windows.Forms.dll

using System;

// The delegates
public delegate void DisplayMessageEventHandler(string text);
public delegate void UserJoinedEventHandler(string user);
public delegate void UserLeftEventHandler(string user);

public class Display
{
  public void ConsoleMessage(string text) 
  {
    Console.WriteLine("MESSAGE: " + text);
  }
 
  public void AnnoyingMessage(string text) 
  {
    System.Windows.Forms.MessageBox.Show("MESSAGE: " + text);
  }
}

public class ChatRoomClient
{   
  public static void Main() 
  {
    Display display = new Display();
    ChatRoomServer server = new ChatRoomServer();
    server.DisplayMessage += new 
      DisplayMessageEventHandler(display.ConsoleMessage);
    server.DisplayMessage += new 
      DisplayMessageEventHandler(display.AnnoyingMessage);
    //...
    server.Run();
    //...
    server.DisplayMessage -= new 
      DisplayMessageEventHandler(display.ConsoleMessage);
    server.DisplayMessage -= new 
      DisplayMessageEventHandler(display.AnnoyingMessage);
  }
}

public class ChatRoomServer
{
  // The events
  public event DisplayMessageEventHandler DisplayMessage;
  public event UserJoinedEventHandler UserJoined;
  public event UserLeftEventHandler UserLeft;

  public void Run()
  {
    //...
    // The callback
    if (DisplayMessage != null) DisplayMessage("text");
    //...
  }
}