' Before compiling, obtain an Interop Assembly for shdocvw.dll.  If a PIA isn't available,
' run TLBIMP on it.  Then run:
' vbc Listing5_7vb.vb /r:SHDocVw.dll

Imports System
Imports SHDocVw
Imports System.Runtime.InteropServices

Public Class BrowserListener
  Implements DWebBrowserEvents2

  Private icp As UCOMIConnectionPoint ' The connection point
  Private cookie As Integer = -1      ' The cookie for the connection

  Public Sub New()
    Dim ie As New InternetExplorer()
 
    ' Call QueryInterface for IConnectionPointContainer
    Dim icpc As UCOMIConnectionPointContainer = CType(ie, UCOMIConnectionPointContainer)
 
    ' Find the connection point for the 
    ' DWebBrowserEvents2 source interface
    Dim g As Guid = GetType(DWebBrowserEvents2).GUID
    icpc.FindConnectionPoint(g, icp)
      
    ' Pass a pointer to the host to the connection point
    icp.Advise(Me, cookie)
      
    ' Show the browser
    ie.Visible = True
    ie.GoHome()
  End Sub
  
  Protected Overloads Overrides Sub Finalize()
    ' End the connection
    If cookie <> -1 Then
      icp.Unadvise(cookie)
    End If
    MyBase.Finalize()
  End Sub

  ' Event handlers for all of the source interface's methods

  Public Sub DownloadBegin() Implements DWebBrowserEvents2.DownloadBegin
    Console.WriteLine("DownloadBegin")
  End Sub

  Public Sub NavigateComplete2(pDisp As Object, ByRef URL As Object) Implements DWebBrowserEvents2.NavigateComplete2
    Console.WriteLine("NavigateComplete2: " & URL)
  End Sub
   
  Public Sub OnQuit() Implements DWebBrowserEvents2.OnQuit
    Console.WriteLine("OnQuit")
 
    ' End the connection
    icp.Unadvise(cookie)
    cookie = -1
 
    Environment.Exit(0)
  End Sub

  Public Sub OnStatusBar(StatusBar As Boolean) Implements DWebBrowserEvents2.OnStatusBar
    Console.WriteLine("OnStatusBar: " & StatusBar)
  End Sub

  Public Sub BeforeNavigate2(pDisp As Object, ByRef URL As Object, ByRef Flags As Object, ByRef TargetFrameName As Object, _
    ByRef PostData As Object, ByRef Headers As Object, ByRef Cancel As Boolean) Implements DWebBrowserEvents2.BeforeNavigate2
    Console.WriteLine("BeforeNavigate2: " & URL)
  End Sub
  
  Public Sub ClientToHostWindow(ByRef CX As Integer, ByRef CY As Integer) Implements DWebBrowserEvents2.ClientToHostWindow
    Console.WriteLine("ClientToHostWindow: (" & CX & ", " & CY & ")")
  End Sub

  Public Sub CommandStateChange(Command As Integer, Enable As Boolean) Implements DWebBrowserEvents2.CommandStateChange
    Console.WriteLine("CommandStateChange: command=" & Command & ", enable=" & Enable)
  End Sub

  Public Sub DocumentComplete(pDisp As Object, ByRef URL As Object) Implements DWebBrowserEvents2.DocumentComplete
    Console.WriteLine("DocumentComplete: " & URL)
  End Sub
   
  Public Sub DownloadComplete() Implements DWebBrowserEvents2.DownloadComplete
    Console.WriteLine("DownloadComplete")
  End Sub

  Public Sub FileDownload(ByRef Cancel As Boolean) Implements DWebBrowserEvents2.FileDownload
    Console.WriteLine("FileDownload: cancel=" & Cancel)
  End Sub
   
  Public Sub NavigateError(pDisp As Object, ByRef URL As Object, ByRef Frame As Object, _
    ByRef StatusCode As Object, ByRef Cancel As Boolean) Implements DWebBrowserEvents2.NavigateError
    Console.WriteLine("NavigateError: " & URL)
  End Sub
  
  Public Sub NewWindow2(ByRef ppDisp As Object, ByRef Cancel As Boolean) Implements DWebBrowserEvents2.NewWindow2
    Console.WriteLine("NewWindow2: cancel=" & Cancel)
  End Sub
   
  Public Sub OnFullScreen(FullScreen As Boolean) Implements DWebBrowserEvents2.OnFullScreen
    Console.WriteLine("OnFullScreen: " & FullScreen)
  End Sub
   
  Public Sub OnMenuBar(MenuBar As Boolean) Implements DWebBrowserEvents2.OnMenuBar
    Console.WriteLine("OnMenuBar: " & MenuBar)
  End Sub
  
  Public Sub OnTheaterMode(TheaterMode As Boolean) Implements DWebBrowserEvents2.OnTheaterMode
    Console.WriteLine("OnTheaterMode: " & TheaterMode)
  End Sub 
  
  Public Sub OnToolBar(ToolBar As Boolean) Implements DWebBrowserEvents2.OnToolBar
    Console.WriteLine("OnToolBar: " & ToolBar)
  End Sub 

  Public Sub OnVisible(Visible As Boolean) Implements DWebBrowserEvents2.OnVisible
    Console.WriteLine("OnVisible: " & Visible)
  End Sub

  Public Sub PrintTemplateInstantiation(pDisp As Object) Implements DWebBrowserEvents2.PrintTemplateInstantiation
    Console.WriteLine("PrintTemplateInstantiation")
  End Sub 
 
  Public Sub PrintTemplateTeardown(pDisp As Object) Implements DWebBrowserEvents2.PrintTemplateTeardown
    Console.WriteLine("PrintTemplateTeardown")
  End Sub 

  Public Sub PrivacyImpactedStateChange(bImpacted As Boolean) Implements DWebBrowserEvents2.PrivacyImpactedStateChange
    Console.WriteLine("PrivacyImpactedStateChange: " & bImpacted)
  End Sub 

  Public Sub ProgressChange(Progress As Integer, ProgressMax As Integer) Implements DWebBrowserEvents2.ProgressChange
    Console.WriteLine("ProgressChange: " & Progress & " out of " & ProgressMax)
  End Sub 

  Public Sub PropertyChange(szProperty As String) Implements DWebBrowserEvents2.PropertyChange
    Console.WriteLine("PropertyChange: " & szProperty)
  End Sub 

  Public Sub SetSecureLockIcon(SecureLockIcon As Integer) Implements DWebBrowserEvents2.SetSecureLockIcon
    Console.WriteLine("SetSecureLockIcon: " & SecureLockIcon)
  End Sub 

  Public Sub StatusTextChange([Text] As String) Implements DWebBrowserEvents2.StatusTextChange
    Console.WriteLine("StatusTextChange: " & [Text])
  End Sub 

  Public Sub TitleChange([Text] As String) Implements DWebBrowserEvents2.TitleChange
    Console.WriteLine("TitleChange: " & [Text])
  End Sub 

  Public Sub UpdatePageStatus(pDisp As Object, ByRef nPage As Object, ByRef fDone As Object) Implements DWebBrowserEvents2.UpdatePageStatus
    Console.WriteLine("UpdatePageStatus: " & nPage)
  End Sub 

  Public Sub WindowClosing(IsChildWindow As Boolean, ByRef Cancel As Boolean) Implements DWebBrowserEvents2.WindowClosing
    Console.WriteLine("WindowClosing: childWindow=" & IsChildWindow & ", cancel=" & Cancel)
  End Sub 

  Public Sub WindowSetHeight(Height As Integer) Implements DWebBrowserEvents2.WindowSetHeight
    Console.WriteLine("WindowSetHeight: " & Height)
  End Sub 

  Public Sub WindowSetLeft(Left As Integer) Implements DWebBrowserEvents2.WindowSetLeft
    Console.WriteLine("WindowSetLeft: " & Left)
  End Sub 

  Public Sub WindowSetResizable(Resizable As Boolean) Implements DWebBrowserEvents2. WindowSetResizable
    Console.WriteLine("WindowSetResizable: " & Resizable)
  End Sub 

  Public Sub WindowSetTop(Top As Integer) Implements DWebBrowserEvents2.WindowSetTop
    Console.WriteLine("WindowSetTop: " & Top)
  End Sub 

  Public Sub WindowSetWidth(Width As Integer) Implements DWebBrowserEvents2.WindowSetWidth
    Console.WriteLine("WindowSetWidth: " & Width)
  End Sub 

  <MTAThread> _
  Public Shared Sub Main()
    Dim host As New BrowserListener()

    ' Keep the program running while Internet Explorer is open
    Console.WriteLine("*** Press Enter to quit ***")
    Console.Read()
  End Sub

End Class