// To compile:
// csc Listing5_8cs.cs /r:SHDocVw.dll

using System;
using SHDocVw;

public class BrowserListener
{
  private InternetExplorer ie;

  public BrowserListener()
  {
    ie = new InternetExplorer();

    // Hook up event handlers to the events we care about
    ie.DocumentComplete += new 
      DWebBrowserEvents2_DocumentCompleteEventHandler(DocumentComplete);
    ie.ProgressChange += new 
      DWebBrowserEvents2_ProgressChangeEventHandler(ProgressChange);
    ie.TitleChange += new 
      DWebBrowserEvents2_TitleChangeEventHandler(TitleChange);

    // Events corresponding to the non-default source interface:
    ((DWebBrowserEvents_Event)ie).WindowResize += new
      DWebBrowserEvents_WindowResizeEventHandler(WindowResize);
    ((DWebBrowserEvents_Event)ie).Quit += new
      DWebBrowserEvents_QuitEventHandler(Quit);

    // Show the browser
    ie.Visible = true;
    ie.GoHome();
  }

  public void DocumentComplete(object pDisp, ref object URL)
  {
    Console.WriteLine("DocumentComplete: " + URL);
  }

  public void ProgressChange(int Progress, int ProgressMax)
  {
    Console.WriteLine("ProgressChange: " + Progress +
      " out of " + ProgressMax);
  }

  public void TitleChange(string Text)
  {
    Console.WriteLine("TitleChange: " + Text);
  }

  public void WindowResize()
  {
    Console.WriteLine("WindowResize");
  }

  public void Quit(ref bool Cancel)
  {
    Console.WriteLine("Quit");
    Environment.Exit(0);
  }

  public static void Main()
  {
    BrowserListener listener = new BrowserListener();

    // Keep the program running while Internet Explorer is open
    Console.WriteLine("*** Press Enter to quit ***");
    Console.Read();
  }
}