// Before compiling, compile the VB6 project Project6_1.vbp to create Project6_1.dll.
// Then run "tlbimp Project6_1.dll" to create ComObject.dll.  Then run "ildasm ComObject.dll /out:ComObject.il"
// and change both occurrences of:
//   [in][out] object&  marshal( struct) v
// to:
//   native int v
// in ComObject.il.  Also change both occurrences of:
//   object[] marshal( safearray variant) 
// to:
//   native int
// Then run "ilasm /dll ComObject.il" to create the final ComObject.dll. Then run:
// csc Listing6_2.cs Listing6_1.cs /r:ComObject.dll /m:SafeArrayManipulation

using System;
using ComObject;
using System.Runtime.InteropServices;

public class SafeArrayManipulation
{
  // This signature is customized for the COM object.
  // For general use, rgIndices should be defined as an array: int [] rgIndices
  // and the third parameter should be an IntPtr return value instead.
  [DllImport("oleaut32.dll", PreserveSig=false)]
  extern static void SafeArrayGetElement(IntPtr psa, ref int rgIndices, out Variant retVal);

  [DllImport("oleaut32.dll", PreserveSig=false)]
  extern static int SafeArrayGetLBound(IntPtr psa, uint nDim);

  [DllImport("oleaut32.dll", PreserveSig=false)]
  extern static int SafeArrayGetUBound(IntPtr psa, uint nDim);

  public static void Main()
  {
    Class1 obj = new Class1();
    IntPtr psa = obj.ReturnPtrToSafeArray();

    // Get the SAFEARRAY bounds
    int lBound = SafeArrayGetLBound(psa, 1); 
    int uBound = SafeArrayGetUBound(psa, 1); 

    for (int i = lBound; i <= uBound; i++) 
    {
      // Extract a pointer to the element
      Variant v;
      SafeArrayGetElement(psa, ref i, out v);
      // Convert the VT_RECORD Variant to the wrapped value type
      object o = new POINT();
      VT_RECORDWorkaround.VT_RECORDToStructure(v, ref o);
      POINT p = (POINT)o;
      // Finally, print the element
      Console.WriteLine(p.x + " " + p.y);
    }
  }
}