' To compile, run TLBIMP on dx7vb.dll to create DxVBLib.dll.  Then run:
' vbc Listing6_3.vb /r:System.Windows.Forms.dll /r:System.dll /r:DxVBLib.dll

Imports System
Imports System.Windows.Forms
Imports DxVBLib

Public Class Form1
  Inherits Form
  Implements DirectXEvent

  Dim performance As DirectMusicPerformance

  ' Callback method (called on a different thread)
  Private Sub DXCallback(eventid As Integer) _
    Implements DirectXEvent.DxCallBack

    Dim msg As DMUS_NOTIFICATION_PMSG
    
    Try
      ' Fails since DirectMusicPerformance is not marshalable
      performance.GetNotificationPMSG(msg)
    Catch ex as Exception
      MessageBox.Show(ex.ToString())
    End Try
  End Sub

  ' Constructor   
  Public Sub New()
    MyBase.New

    Dim directX As DirectX7 = new DirectX7()

    ' Set up the music
    performance = directX.DirectMusicPerformanceCreate()
    performance.Init(Nothing, 0)
    performance.SetPort(-1, 4)
    Dim loader As DirectMusicLoader = directX.DirectMusicLoaderCreate()
    Dim segment As DirectMusicSegment
    segment = loader.LoadSegment("heartland2.sgt")
    Dim style As DirectMusicStyle = loader.LoadStyle("heartlnd.sty")

    ' Set up the callback
    performance.AddNotificationType( _
      CONST_DMUS_NOTIFICATION_TYPE.DMUS_NOTIFY_ON_MEASUREANDBEAT)
    Dim notification As Integer = directX.CreateEvent(Me)
    performance.SetNotificationHandle(notification)

    ' Begin playing the music
    performance.PlaySegment(segment, 0, 0)
  End Sub

  Public Shared Sub Main() 
    Application.Run(new Form1())
  End Sub
End Class