' To compile, run TLBIMP on dx7vb.dll to create DxVBLib.dll.  Then run:
' vbc Listing6_4.vb /r:System.Windows.Forms.dll /r:System.dll /r:DxVBLib.dll

Imports System
Imports System.Windows.Forms
Imports System.Threading
Imports DxVBLib

Public Class Form1
  Inherits Form
  Implements DirectXEvent

  Dim performance As DirectMusicPerformance
  Dim mre As ManualResetEvent 
  Shared t As Thread

  ' Callback method (called on a third thread)
  Private Sub DXCallback(eventid As Integer) _
    Implements DirectXEvent.DxCallBack
    Try
      mre.Set()
    Catch ex as Exception
      MessageBox.Show(ex.ToString())
    End Try
  End Sub

  ' Constructor   
  Public Sub New()
    MyBase.New
    t = New Thread(New ThreadStart(AddressOf Run))
    t.ApartmentState = ApartmentState.STA
    t.Start()
  End Sub

  ' A second thread that creates the COM objects
  ' and does the work of the callback
  Private Sub Run
    Dim directX As DirectX7 = new DirectX7()

    ' Set up the music
    performance = directX.DirectMusicPerformanceCreate()
    performance.Init(Nothing, 0)
    performance.SetPort(-1, 4)
    Dim loader As DirectMusicLoader = directX.DirectMusicLoaderCreate()
    Dim segment As DirectMusicSegment 
    segment = loader.LoadSegment("heartland2.sgt")
    Dim style As DirectMusicStyle = loader.LoadStyle("heartlnd.sty")

    ' Set up the callback
    performance.AddNotificationType( _
      CONST_DMUS_NOTIFICATION_TYPE.DMUS_NOTIFY_ON_MEASUREANDBEAT)
    Dim notification As Integer = directX.CreateEvent(Me)
    performance.SetNotificationHandle(notification)

    ' Initialize ManualResetEvent to an unsignaled state
    mre = New ManualResetEvent(False)

    ' Begin playing the music
    performance.PlaySegment(segment, 0, 0)

    While True
      mre.WaitOne()
      SameThreadCallback()
      mre.Reset()
    End While
  End Sub

  ' Callback implementation that runs on the second thread
  Private Sub SameThreadCallback
    Dim msg As DMUS_NOTIFICATION_PMSG
    ' Calling on DirectMusicPerformance succeeds when called 
    ' on the same thread the object was created on
    performance.GetNotificationPMSG(msg)
  End Sub

  Public Shared Sub Main() 
    Application.Run(new Form1())
    t.Abort()
  End Sub
End Class