// To compile:
// csc /t:library StringValidator.cs /r:System.dll

using System.Text.RegularExpressions;
using System.Reflection;

[assembly:AssemblyKeyFile("KeyFile.snk")]

public class StringValidator
{
  public bool IsPhoneNumber(string s)
  {
    return Regex.IsMatch(s, 
      @"^(((\(\d{3}\)( )?)|(\d{3}( |\-)))\d{3}\-\d{4})$");
  }

  public bool IsZipCode(string s)
  {
    return Regex.IsMatch(s, @"^((\d{5})|(\d{5}\-\d{4}))$");
  }

  public bool IsSSN(string s)
  {
    return Regex.IsMatch(s, @"^\d{3}\-\d{2}\-\d{4}$");
  }
}