' To compile:
' vbc /t:library LabeledTextBox.vb /r:System.Windows.Forms.dll /r:System.Drawing.dll /r:System.dll

Imports System
Imports System.Security
Imports Microsoft.Win32
Imports System.Windows.Forms
Imports System.Runtime.InteropServices

<Assembly:AllowPartiallyTrustedCallersAttribute>

Public Class LabeledTextBox
  Inherits UserControl

  Private textBox1 As System.Windows.Forms.TextBox
  Private label1 As System.Windows.Forms.Label
  Private components As System.ComponentModel.Container = Nothing
   
  ' Custom Registration Function
  <ComRegisterFunction> _
  Private Shared Sub ComRegisterFunction(t As Type)
    Dim key As RegistryKey = Registry.ClassesRoot.OpenSubKey("CLSID\" & t.GUID.ToString("B"), True)
    ' Step 1
    key.CreateSubKey("Control")
    ' Step 2
    key.CreateSubKey("Implemented Categories\{40FC6ED4-2438-11CF-A3DB-080036F12502}")
    ' Step 3
    key.CreateSubKey("MiscStatus").SetValue("", "131457")
    ' Step 4
    key.CreateSubKey("TypeLib").SetValue("", Marshal.GetTypeLibGuidForAssembly(t.Assembly).ToString("B"))
    ' Step 5
    Dim version As String = t.Assembly.GetName().Version.Major.ToString() & "." & t.Assembly.GetName().Version.Minor.ToString()
    If version = "0.0" Then
      version = "1.0"
    End If
    key.CreateSubKey("Version").SetValue("", version)
    key.Close()
  End Sub

  ' Custom Unregistration Function
  <ComUnregisterFunction> _
  Private Shared Sub ComUnregisterFunction(t As Type)
    Try
      Registry.ClassesRoot.DeleteSubKeyTree("CLSID\" & t.GUID.ToString("B"))
    Catch e As ArgumentException
      ' Ignore exception thrown if key doesn't exist
    End Try
  End Sub
    
  Public Sub New()
    ' This call is required by the Windows.Forms Form Designer
    InitializeComponent()
  End Sub
   
  Public Property LabelText() As String
    Get
      Return label1.Text
    End Get
    Set
      label1.Text = value
    End Set
  End Property

  Public Property TextBoxText() As String
    Get
      Return textBox1.Text
    End Get
    Set
      textBox1.Text = value
    End Set
  End Property
    
  ' Clean up any resources being used
  Protected Overrides Overloads Sub Dispose(disposing As Boolean)
    If disposing Then
      If Not (components Is Nothing) Then
        components.Dispose()
      End If
    End If
    MyBase.Dispose(disposing)
  End Sub
   
  ' Required method for Designer support
  Private Sub InitializeComponent()
    Me.textBox1 = New System.Windows.Forms.TextBox()
    Me.label1 = New System.Windows.Forms.Label()
    Me.SuspendLayout()
      
    Me.textBox1.Anchor = System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right
    Me.textBox1.Location = New System.Drawing.Point(112, 0)
    Me.textBox1.Multiline = True
    Me.textBox1.Name = "textBox1"
    Me.textBox1.Size = New System.Drawing.Size(144, 20)
    Me.textBox1.TabIndex = 0
    Me.textBox1.Text = "TextBox"
      
    Me.label1.Anchor = System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left Or System.Windows.Forms.AnchorStyles.Right
    Me.label1.Name = "label1"
    Me.label1.Size = New System.Drawing.Size(112, 20)
    Me.label1.TabIndex = 1
    Me.label1.Text = "Label"
    Me.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight
      
    Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.label1, Me.textBox1})
    Me.Name = "LabeledTextBox"
    Me.Size = New System.Drawing.Size(256, 20)
    Me.ResumeLayout(False)
  End Sub
End Class