// Note: Be sure to link with mscoree.lib to avoid an unresolved external symbol
//       for ClrCreateManagedInstance

#define _WIN32_DCOM
#include <stdio.h>
#include <wtypes.h>

// The header file that declares ClrCreateManagedInstance
#include "C:\\INSERT PATH OF SDK INCLUDE FILES HERE\\mscoree.h"

IDispatch* pDisp = NULL;
IUnknown* pUnk = NULL;
VARIANT result;

void Cleanup()
{
  if (pUnk) pUnk->Release();
  if (pDisp) pDisp->Release();
  VariantClear(&result);
  CoUninitialize();
};

int main(int argc, char* argv[])
{
  HRESULT hresult;

  // Initialize COM
  hresult = CoInitializeEx(NULL, COINIT_MULTITHREADED);
  if (FAILED(hresult)) 
  {
    printf("ERROR: Cannot initialize COM: 0x%x\n", hresult);
    Cleanup();
    return -1;
  }

  // Create an instance of the System.CodeDom.CodeObject class
  hresult = ClrCreateManagedInstance(L"System.CodeDom.CodeObject, System, Version=1.0.3300.0, Culture=neutral, PublicKeyToken=b77a5c561934e089",
    IID_IUnknown, (void**)&pUnk);
  if (FAILED(hresult)) 
  { 
    printf("ERROR: Could not create instance: 0x%x\n", hresult);
    Cleanup();
    return -1;
  }

  // Get the IDispatch interface so we can call the UserData property
  hresult = pUnk->QueryInterface(IID_IDispatch, (void**)&pDisp);
  if (FAILED(hresult)) 
  { 
    printf("ERROR: Could not get IDispatch interface pointer: 0x%x\n",
      hresult);
    Cleanup();
    return -1;
  }

  // Get the DISPID for the UserData property
  OLECHAR* name = L"UserData";
  DISPID dispid;
  hresult = pDisp->GetIDsOfNames(IID_NULL, &name, 1, GetUserDefaultLCID(),
    &dispid);
  if (FAILED(hresult)) 
  { 
    printf("ERROR: GetIDsOfNames failed: 0x%x\n", hresult);
    Cleanup();
    return -1;
  }

  // Invoke the UserData property
  VariantInit(&result);
  DISPPARAMS params = { NULL, NULL, 0, 0 };
 
  hresult = pDisp->Invoke(dispid, IID_NULL, GetUserDefaultLCID(), 
    DISPATCH_PROPERTYGET, &params, &result, NULL, NULL);
  if (FAILED(hresult)) 
  { 
    printf("ERROR: Invoke failed: 0x%x\n", hresult);
    Cleanup();
    return -1;
  }

  Cleanup();
  return 0;
};