// To compile:
// csc /t:library KeywordAttribute.cs

using System;

public interface IKeyword
{
  string Keyword { get; }
  int Relevance { get; set; }
}

[AttributeUsage(AttributeTargets.All, AllowMultiple=true)]
public class KeywordAttribute : Attribute, IKeyword
{
  private string keyword;
  private int relevance;

  // Constructor - called when the attribute is applied
  public KeywordAttribute(string word)
  {
    this.keyword = word;
    this.relevance = 5;
  }

  // Read-only property to get the keyword
  public virtual string Keyword
  {
    get { return keyword; }
  }

  // Property to get/set the relevance
  public virtual int Relevance
  {
    get { return relevance; }
    set { relevance = value; }
  }
}