' To compile:
' vbc /t:library KeywordAttribute.vb

Imports System

Public Interface IKeyword
   ReadOnly Property Keyword() As String
   Property Relevance() As Integer
End Interface

<AttributeUsage(AttributeTargets.All, AllowMultiple:=True)> _
Public Class KeywordAttribute
  Inherits Attribute
  Implements IKeyword

  Private _keyword As String
  Private _relevance As Integer
   
  ' Constructor - called when the attribute is applied
  Public Sub New(word As String)
    Me._keyword = word
    Me._relevance = 5
  End Sub
   
  ' Read-only property to get the keyword
  Public Overridable ReadOnly Property Keyword() As String Implements IKeyword.Keyword
    Get
      Return _keyword
    End Get
  End Property 
  
  ' Property to get/set the relevance
  Public Overridable Property Relevance() As Integer Implements IKeyword.Relevance
    Get
      Return _relevance
    End Get
    Set
      _relevance = value
    End Set
  End Property
End Class