// To compile:
// csc /t:library ClassWithCustomRegistration.cs

using System;
using System.Runtime.InteropServices;

public class ClassWithCustomRegistration
{
  [ComRegisterFunction]
  private static void RegisterFunction(Type t)
  {
    // Add a custom key to the registry
    Microsoft.Win32.RegistryKey key;
    key = Microsoft.Win32.Registry.ClassesRoot.CreateSubKey( 
      "CLSID\\" + t.GUID.ToString("B") + "\\Implemented Categories\\" 
      + "{00021493-0000-0000-C000-000000000046}");
    key.Close();
  }
    
  [ComUnregisterFunction]
  private static void UnregisterFunction(Type t)
  {
    // Undo the work from the registration function
    Microsoft.Win32.Registry.ClassesRoot.DeleteSubKey(
      "CLSID\\" + t.GUID.ToString("B") + "\\Implemented Categories\\"
      + "{00021493-0000-0000-C000-000000000046}", false);
  }
}