' To compile:
' vbc /t:library ComFriendlyForm.vb /r:System.Windows.Forms.dll /r:System.Drawing.dll /r:System.dll

Imports System
Imports System.Globalization
Imports System.Windows.Forms
Imports System.ComponentModel
Imports System.Runtime.InteropServices

' The source interface representing all events for Form
<InterfaceType(ComInterfaceType.InterfaceIsIDispatch)> _
Public Interface IFormEvents
  ' Component's event
  <DispId(1)> _
  Sub Disposed(sender As Object, e As EventArgs)
   
  ' Control's events with COM-visible parameters
  <DispId(2)> _
  Sub BackColorChanged(sender As Object, e As EventArgs)
  <DispId(3)> _
  Sub BackgroundImageChanged(sender As Object, e As EventArgs)
  <DispId(4)> _
  Sub BindingContextChanged(sender As Object, e As EventArgs)
  <DispId(5)> _
  Sub CausesValidationChanged(sender As Object, e As EventArgs)
  <DispId(6)> _
  Sub Click(sender As Object, e As EventArgs)
  <DispId(7)> _
  Sub ContextMenuChanged(sender As Object, e As EventArgs)
  <DispId(8)> _
  Sub CursorChanged(sender As Object, e As EventArgs)
  <DispId(9)> _
  Sub DockChanged(sender As Object, e As EventArgs)
  <DispId(10)> _
  Sub DoubleClick(sender As Object, e As EventArgs)
  <DispId(11)> _
  Sub DragDrop(sender As Object, e As DragEventArgs)
  <DispId(12)> _
  Sub DragEnter(sender As Object, e As DragEventArgs)
  <DispId(13)> _
  Sub DragLeave(sender As Object, e As EventArgs)
  <DispId(14)> _
  Sub DragOver(sender As Object, e As DragEventArgs)
  <DispId(15)> _
  Sub EnabledChanged(sender As Object, e As EventArgs)
  <DispId(16)> _
  Sub Enter(sender As Object, e As EventArgs)
  <DispId(17)> _
  Sub FontChanged(sender As Object, e As EventArgs)
  <DispId(18)> _
  Sub ForeColorChanged(sender As Object, e As EventArgs)
  <DispId(19)> _
  Sub GiveFeedback(sender As Object, e As GiveFeedbackEventArgs)
  <DispId(20)> _
  Sub GotFocus(sender As Object, e As EventArgs)
  <DispId(21)> _
  Sub HandleCreated(sender As Object, e As EventArgs)
  <DispId(22)> _
  Sub HandleDestroyed(sender As Object, e As EventArgs)
  <DispId(23)> _
  Sub HelpRequested(sender As Object, e As HelpEventArgs)
  <DispId(24)> _
  Sub ImeModeChanged(sender As Object, e As EventArgs)
  <DispId(25)> _
  Sub KeyDown(sender As Object, e As KeyEventArgs)
  <DispId(26)> _
  Sub KeyPress(sender As Object, e As KeyPressEventArgs)
  <DispId(27)> _
  Sub KeyUp(sender As Object, e As KeyEventArgs)
  <DispId(28)> _
  Sub Leave(sender As Object, e As EventArgs)
  <DispId(29)> _
  Sub LocationChanged(sender As Object, e As EventArgs)
  <DispId(30)> _
  Sub LostFocus(sender As Object, e As EventArgs)
  <DispId(31)> _
  Sub MouseDown(sender As Object, e As MouseEventArgs)
  <DispId(32)> _
  Sub MouseEnter(sender As Object, e As EventArgs)
  <DispId(33)> _
  Sub MouseHover(sender As Object, e As EventArgs)
  <DispId(34)> _
  Sub MouseLeave(sender As Object, e As EventArgs)
  <DispId(35)> _
  Sub MouseMove(sender As Object, e As MouseEventArgs)
  <DispId(36)> _
  Sub MouseUp(sender As Object, e As MouseEventArgs)
  <DispId(37)> _
  Sub MouseWheel(sender As Object, e As MouseEventArgs)
  <DispId(38)> _
  Sub Move(sender As Object, e As EventArgs)
  <DispId(39)> _
  Sub ParentChanged(sender As Object, e As EventArgs)
  <DispId(40)> _
  Sub Resize(sender As Object, e As EventArgs)
  <DispId(41)> _
  Sub RightToLeftChanged(sender As Object, e As EventArgs)
  <DispId(42)> _
  Sub SizeChanged(sender As Object, e As EventArgs)
  <DispId(43)> _
  Sub StyleChanged(sender As Object, e As EventArgs)
  <DispId(44)> _
  Sub SystemColorsChanged(sender As Object, e As EventArgs)
  <DispId(45)> _
  Sub TabIndexChanged(sender As Object, e As EventArgs)
  <DispId(46)> _
  Sub TabStopChanged(sender As Object, e As EventArgs)
  <DispId(47)> _
  Sub TextChanged(sender As Object, e As EventArgs)
  <DispId(48)> _
  Sub Validated(sender As Object, e As EventArgs)
  <DispId(49)> _
  Sub VisibleChanged(sender As Object, e As EventArgs)
  <DispId(50)> _
  Sub QueryAccessibilityHelp(sender As Object, e As QueryAccessibilityHelpEventArgs)
  <DispId(51)> _
  Sub QueryContinueDrag(sender As Object, e As QueryContinueDragEventArgs)
   
  ' Form's events with COM-visible parameters
  <DispId(52)> _
  Sub Activated(sender As Object, e As EventArgs)
  <DispId(53)> _
  Sub Closed(sender As Object, e As EventArgs)
  <DispId(54)> _
  Sub Deactivate(sender As Object, e As EventArgs)
  <DispId(55)> _
  Sub Load(sender As Object, e As EventArgs)
  <DispId(56)> _
  Sub MaximizedBoundsChanged(sender As Object, e As EventArgs)
  <DispId(57)> _
  Sub MaximumSizeChanged(sender As Object, e As EventArgs)
  <DispId(58)> _
  Sub MdiChildActivate(sender As Object, e As EventArgs)
  <DispId(59)> _
  Sub MenuComplete(sender As Object, e As EventArgs)
  <DispId(60)> _
  Sub MenuStart(sender As Object, e As EventArgs)
  <DispId(61)> _
  Sub MinimumSizeChanged(sender As Object, e As EventArgs)
   
  ' Control's events with COM-invisible parameters
  <DispId(62)> _
  Sub ChangeUICues(sender As Object, changeFocus As Boolean, changeKeyboard As Boolean, showFocus As Boolean, showKeyboard As Boolean)
  <DispId(63)> _
  Sub ControlAdded(sender As Object, control As IComponent)
  <DispId(64)> _
  Sub ControlRemoved(sender As Object, control As IComponent)
  <DispId(65)> _
  Sub Invalidated(sender As Object, x As Integer, y As Integer, width As Integer, height As Integer)
  <DispId(66)> _
  Sub Layout(sender As Object, affectedControl As IComponent, affectedProperty As String)
  <DispId(67)> _
  Sub Paint(sender As Object, hdc As IntPtr, x As Integer, y As Integer, width As Integer, height As Integer)
  <DispId(68)> _
  Sub Validating(sender As Object, ByRef cancel As Boolean)

  ' Form's events with COM-invisible parameters
  <DispId(69)> _
  Sub Closing(sender As Object, ByRef cancel As Boolean)
  <DispId(70)> _
  Sub InputLanguageChanged(sender As Object, charSet As Byte, culture As CultureInfo, inputLanguageHandle As IntPtr, inputLanguageLayoutName As String)
  <DispId(71)> _
  Sub InputLanguageChanging(sender As Object, ByRef cancel As Boolean, sysCharSet As Boolean, culture As CultureInfo, inputLanguageHandle As IntPtr, inputLanguageLayoutName As String)
End Interface

' A Windows Form that exposes its events to COM using connection points
<ComSourceInterfaces(GetType(IFormEvents))> _
Public Class ComFriendlyForm
  Inherits Form
   
  '-------------------------------------------------------
  ' Delegates for the COM-friendly event handlers
  '-------------------------------------------------------
  Delegate Sub UICuesExpandedEventHandler(sender As Object, changeFocus As Boolean, changeKeyboard As Boolean, showFocus As Boolean, showKeyboard As Boolean)
  Delegate Sub ControlExpandedEventHandler(sender As Object, control As IComponent)
  Delegate Sub InvalidateExpandedEventHandler(sender As Object, x As Integer, y As Integer, width As Integer, height As Integer)
  Delegate Sub LayoutExpandedEventHandler(sender As Object, affectedControl As IComponent, affectedProperty As String)
  Delegate Sub PaintExpandedEventHandler(sender As Object, hdc As IntPtr, x As Integer, y As Integer, width As Integer, height As Integer)
  Delegate Sub CancelExpandedEventHandler(sender As Object, ByRef cancel As Boolean)
  Delegate Sub InputLanguageChangedExpandedEventHandler(sender As Object, charSet As Byte, culture As CultureInfo, inputLanguageHandle As IntPtr, inputLanguageLayoutName As String)
  Delegate Sub InputLanguageChangingExpandedEventHandler(sender As Object, ByRef cancel As Boolean, sysCharSet As Boolean, culture As CultureInfo, inputLanguageHandle As IntPtr, inputLanguageLayoutName As String)
   
  '-------------------------------------------------------
  ' New events using COM-friendly delegates 
  ' (with the same names as the unfriendly events)
  '-------------------------------------------------------
  Public Shadows Event ChangeUICues As UICuesExpandedEventHandler
  Public Shadows Event ControlAdded As ControlExpandedEventHandler
  Public Shadows Event ControlRemoved As ControlExpandedEventHandler
  Public Shadows Event Invalidated As InvalidateExpandedEventHandler
  Public Shadows Event Layout As LayoutExpandedEventHandler
  Public Shadows Event Paint As PaintExpandedEventHandler
  Public Shadows Event Validating As CancelExpandedEventHandler
  Public Shadows Event Closing As CancelExpandedEventHandler
  Public Shadows Event InputLanguageChanged As InputLanguageChangedExpandedEventHandler
  Public Shadows Event InputLanguageChanging As InputLanguageChangingExpandedEventHandler
   
  '-------------------------------------------------------
  ' Overridden On<Event> methods that not only call the
  ' base On<Event> methods but also raise the new COM-friendly
  ' events in case anyone's listening
  '-------------------------------------------------------
  Protected Overrides Sub OnChangeUICues(e As UICuesEventArgs)
    MyBase.OnChangeUICues(e)
    RaiseEvent ChangeUICues(Me, e.ChangeFocus, e.ChangeKeyboard, e.ShowFocus, e.ShowKeyboard)
  End Sub

  Protected Overrides Sub OnControlAdded(e As ControlEventArgs)
    MyBase.OnControlAdded(e)
    RaiseEvent ControlAdded(Me, e.Control)
  End Sub

  Protected Overrides Sub OnControlRemoved(e As ControlEventArgs)
    MyBase.OnControlRemoved(e)
    RaiseEvent ControlRemoved(Me, e.Control)
  End Sub

  Protected Overrides Sub OnInvalidated(e As InvalidateEventArgs)
    MyBase.OnInvalidated(e)
    RaiseEvent Invalidated(Me, e.InvalidRect.X, e.InvalidRect.Y, e.InvalidRect.Width, e.InvalidRect.Height)
  End Sub

  Protected Overrides Sub OnLayout(e As LayoutEventArgs)
    MyBase.OnLayout(e)
    RaiseEvent Layout(Me, e.AffectedControl, e.AffectedProperty)
  End Sub

  Protected Overrides Sub OnPaint(e As PaintEventArgs)
    MyBase.OnPaint(e)
    Dim hdc As IntPtr = e.Graphics.GetHdc()
    Try
      RaiseEvent Paint(Me, hdc, e.ClipRectangle.X, e.ClipRectangle.Y, e.ClipRectangle.Width, e.ClipRectangle.Height)
    Finally
      e.Graphics.ReleaseHdc(hdc)
    End Try
  End Sub

  Protected Overrides Sub OnInputLanguageChanged(e As InputLanguageChangedEventArgs)
    MyBase.OnInputLanguageChanged(e)
    RaiseEvent InputLanguageChanged(Me, e.CharSet, e.Culture, e.InputLanguage.Handle, e.InputLanguage.LayoutName)
  End Sub

  '-------------------------------------------------------
  ' On<Event> methods that handle raised events then raise
  ' the corresponding COM-friendly events, done this way
  ' due to the by-reference parameter
  '-------------------------------------------------------
  Private Sub HandleValidating(sender As Object, e As CancelEventArgs)
    ' Pass the CancelEventArgs.Cancel value by-reference
    Dim cancel As Boolean = e.Cancel
    RaiseEvent Validating(Me, cancel)
    e.Cancel = cancel
  End Sub

  Private Sub HandleClosing(sender As Object, e As CancelEventArgs)
    ' Pass the CancelEventArgs.Cancel value by-reference
    Dim cancel As Boolean = e.Cancel
    RaiseEvent Closing(Me, cancel)
    e.Cancel = cancel
  End Sub

  Private Sub HandleInputLanguageChanging(sender As Object, e As InputLanguageChangingEventArgs)
    ' Pass the CancelEventArgs.Cancel value by-reference
    Dim cancel As Boolean = e.Cancel
    RaiseEvent InputLanguageChanging(Me, cancel, e.SysCharSet, e.Culture, e.InputLanguage.Handle, e.InputLanguage.LayoutName)
    e.Cancel = cancel
  End Sub

  '-------------------------------------------------------
  ' Constructor
  '-------------------------------------------------------
  Public Sub New()
    AddHandler MyBase.Validating, AddressOf HandleValidating
    AddHandler MyBase.Closing, AddressOf HandleClosing
    AddHandler MyBase.InputLanguageChanging, AddressOf HandleInputLanguageChanging

    Me.Text = ".NET Windows Form"
  End Sub

End Class