// To compile:
// csc /t:library Listing13_3cs.cs

using System;
using System.Runtime.InteropServices;

// Source interface with "event handlers" for COM objects to implement
[InterfaceType(ComInterfaceType.InterfaceIsIDispatch)]
public interface IPhoneEvents
{
  [DispId(1)] void Ring();
  [DispId(2)] void CallerId(string callerName, string callerPhoneNumber);
}

// Delegates for the events
public delegate void RingEventHandler();
public delegate void CallerIdEventHandler(string callerName, 
  string callerPhoneNumber);

[ComSourceInterfaces(typeof(IPhoneEvents))]
public class Phone
{
  public event RingEventHandler Ring;
  public event CallerIdEventHandler CallerId;

  // More methods to communicate with hardware and raise the events...
}