' To compile:
' vbc /t:library Listing13_6.vb

Imports System
Imports Microsoft.VisualBasic

<ComClass(Phone.ClassId, Phone.InterfaceId, Phone.EventsId)> _
Public Class Phone
  ' GUIDs needed for ComClassAttribute
  Public Const ClassId As String = "F7EB2080-18FE-43CE-8FB1-B7CB7DE91C4B"
  Public Const InterfaceId As String _
    = "68146151-1D31-4C75-91D5-7920F8C25798"
  Public Const EventsId As String = "4E4B25B1-7266-41D9-BC09-425394E14D1B"

  ' The events
  Public Event Ring(ByVal sender As Object, ByVal e As EventArgs)
  Public Event CallerId(ByVal sender As Object, _
    ByVal e As CallerIdEventArgs)

  ' On<EventName> methods so subclasses can customize event behavior

  Protected Sub OnRing(ByVal e As EventArgs)
    RaiseEvent Ring(Me, e)
  End Sub

  Protected Sub OnCallerId(ByVal e As CallerIdEventArgs)
    RaiseEvent CallerId(Me, e)
  End Sub

  ' More methods to communicate with hardware...
End Class

' CallerIdEventArgs
Public Class CallerIdEventArgs
  Inherits EventArgs
  Private name As String
  Private phoneNumber As String

  Public Sub New(ByVal callerName As String, _
    ByVal callerPhoneNumber As String)
    name = callerName
    phoneNumber = callerPhoneNumber
  End Sub

  Public ReadOnly Property CallerName() As String
    Get
      Return name
    End Get
  End Property

  Public ReadOnly Property CallerPhoneNumber() As String
    Get
      Return phoneNumber
    End Get
  End Property
End Class