VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ChessBoard"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' To compile, be sure that this VB6 project references mscorlib.tlb.

Implements IHashCodeProvider
Implements IComparer

Private spaces(7, 7) As Byte

Public Property Get Space(x As Integer, y As Integer) As Byte
  Space = spaces(x, y)
End Property

'...

Private Function IComparer_Compare(ByVal x As Variant, _
  ByVal y As Variant) As Long

  ' If two boards have the exact same pieces in the exact
  ' same squares, then they are equal
  For i = 0 To 7
    For J = 0 To 7
      If (x.Space(i, J) <> y.Space(i, J)) Then
        IComparer_Compare = False
        Exit Function
      End If
    Next J
  Next i
  
  IComparer_Compare = True
End Function

Private Function IHashCodeProvider_GetHashCode(ByVal obj As Variant) _
  As Long

  ' Return a simple hash code that is always the same for a given board,
  ' although not all boards will have a unique hash code
  IHashCodeProvider_GetHashCode = 0
  For i = 0 To 7
    For J = 0 To 7
      IHashCodeProvider_GetHashCode = IHashCodeProvider_GetHashCode + _
        i * J * obj.Space(i, J)
    Next J
  Next i
End Function

