VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Formattable"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' To compile, be sure that this VB6 project references mscorlib.tlb.

Option Explicit
Implements IFormattable

Private list(9) As Integer

Private Sub Class_Initialize()
  Dim i As Integer
  For i = LBound(list) To UBound(list)
    list(i) = i
  Next i
End Sub

Private Property Get IFormattable_ToString(ByVal format As String, _
  ByVal formatProvider As mscorlib.IFormatProvider) As String

  ' This formatting is culture-independent, so we ignore the
  ' IFormatProvider instance
  
  ' Clients can pass a null format to accept the default
  If (format = "") Then format = "G"
    
  Select Case format
  
    ' The general formatting code "G" that all IFormattable
    ' implementations must support
    Case "G"
      IFormattable_ToString = "COM Class: MyProject.FormattableClass " & _
        "{C2FBA9E3-B523-47C5-AFB6-F6180EEB6CD4}"
    
    ' Matches System.Guid "N" formatting
    Case "GN"
      IFormattable_ToString = "C2FBA9E3B52347C5AFB6F6180EEB6CD4"
    
    ' Matches System.Guid "D" formatting
    Case "GD"
      IFormattable_ToString = "C2FBA9E3-B523-47C5-AFB6-F6180EEB6CD4"
    
    ' Matches System.Guid "B" formatting
    Case "GB"
      IFormattable_ToString = "{C2FBA9E3-B523-47C5-AFB6-F6180EEB6CD4}"
    
    ' Matches System.Guid "P" formatting
    Case "GP"
      IFormattable_ToString = "(C2FBA9E3-B523-47C5-AFB6-F6180EEB6CD4)"
      
    ' ProgID
    Case "P"
      IFormattable_ToString = "MyProject.FormattableClass"
      
    ' State of the object
    Case "S"
      IFormattable_ToString = "FormattableClass with Array { "
      Dim i As Integer
      For i = LBound(list) To UBound(list)
        IFormattable_ToString = IFormattable_ToString & list(i) & " "
      Next i
      IFormattable_ToString = IFormattable_ToString & "}"
  
    ' Invalid format specifier
    Case Else
      ' Throw a System.FormatException by returning COR_E_FORMAT
      Err.Raise &H80131537, "MyProject", _
        "Invalid format for MyProject.FormattableClass. " & _
        "Expected 'G', 'GN', 'GD', 'GB', 'GP', 'P', or 'S'."
  End Select
End Property
