' To compile:
' vbc Listing18_1.vb

Imports System

Public Module SimpleTiming
  ' PInvoke signatures:
  Declare Function QueryPerformanceCounter Lib "kernel32.dll" _
    (ByRef lpPerformanceCount As Long) As Boolean

  Declare Function QueryPerformanceFrequency Lib "kernel32.dll" _
    (ByRef lpFrequency As Long) As Boolean

  Sub Main()
    Dim timeBefore, timeAfter, frequency As Long
    Dim timeDiff As Double
    Dim i As Integer

    If Not QueryPerformanceFrequency(frequency) Then
      Console.WriteLine("Computer doesn't support performance counters")
      Exit Sub
    End If

    ' Time how long it takes to calculate 100,000,000 square roots
    QueryPerformanceCounter(timeBefore)
    For i = 1 to 100000000
      Math.Sqrt(100)
    Next i
    QueryPerformanceCounter(timeAfter)

    timeDiff = (timeAfter - timeBefore) / frequency

    Console.WriteLine("Time to calculate square root 100,000,000 times: " _
      & timeDiff & " seconds")
  End Sub
End Module