// To compile:
// csc Listing18_10cs.cs

using System;
using System.Runtime.InteropServices;

public class ErrorHandling
{
  [DllImport("ole32.dll", CharSet=CharSet.Unicode, 
    EntryPoint="ProgIDFromCLSID")]
  static extern int ProgIDFromCLSID1([In] ref Guid clsid, 
    out string lplpszProgID);

  [DllImport("ole32.dll", CharSet=CharSet.Unicode, 
    EntryPoint="ProgIDFromCLSID", PreserveSig=false)]
  static extern void ProgIDFromCLSID2([In] ref Guid clsid, 
    out string lplpszProgID);

  public static void Main()
  {
    Guid g = Guid.NewGuid();
    string progID;

    // Check for error by looking for a failure HRESULT value
    int hresult = ProgIDFromCLSID1(ref g, out progID);
    if (hresult < 0)
      Console.WriteLine("The call failed: 0x{0:X}", hresult);

    // Check for error by catching an exception
    try
    {
      ProgIDFromCLSID2(ref g, out progID);
    }
    catch (Exception e)
    {
      Console.WriteLine("The call failed: " + e.ToString());
    }
  }
}