' To compile:
' vbc Listing18_10vb.vb

Imports System
Imports System.Runtime.InteropServices

Public Module ErrorHandling
   
  Declare Unicode Function ProgIDFromCLSID1 Lib "ole32.dll" _
  Alias "ProgIDFromCLSID" (<[In]> ByRef clsid As Guid, ByRef lplpszProgID As String) As Integer
     
  ' Must use DllImport since Declare doesn't support setting PreserveSig to false
  <DllImport("ole32.dll", CharSet:=CharSet.Unicode, EntryPoint:="ProgIDFromCLSID", PreserveSig:=False)> _
  Sub ProgIDFromCLSID2(<[In]> ByRef clsid As Guid, ByRef lplpszProgID As String)
  End Sub
 
  Public Sub Main()
    Dim g As Guid = Guid.NewGuid()
    Dim progID As String
      
    ' Check for error by looking for a failure HRESULT value
    Dim hresult As Integer = ProgIDFromCLSID1(g, progID)
    If hresult < 0 Then
      Console.WriteLine("The call failed: 0x{0:X}", hresult)
    End If 

    ' Check for error by catching an exception
    Try
      ProgIDFromCLSID2(g, progID)
    Catch e As Exception
      Console.WriteLine("The call failed: " + e.ToString())
    End Try
  End Sub
End Module