// To compile:
// csc Listing18_11cs.cs /r:Accessibility.dll

using System;
using System.Text;
using System.Runtime.InteropServices;
using Accessibility;

struct POINT
{ 
  public int x;
  public int y;
}

public class ArrayExample
{
  [DllImport("oleacc.dll", PreserveSig=false)]
  static extern void AccessibleChildren(IAccessible paccContainer,
  int iChildStart, int cChildren, [Out] object [] rgvarChildren,
  out int pcObtained);

  [DllImport("oleacc.dll", PreserveSig=false)]
  static extern void AccessibleObjectFromPoint(POINT ptScreen, 
  out IAccessible ppacc, 
  [MarshalAs(UnmanagedType.Struct)] out object pvarChild);

  [DllImport("user32.dll")]
  static extern bool GetCursorPos(out POINT lpPoint);

  public static void Main()
  {
    IAccessible acc = null;
    POINT p;
    Object var;
    
    try
    {
      if (GetCursorPos(out p))
      {
        // Try to get an accessible object under the cursor
        AccessibleObjectFromPoint(p, out acc, out var);
  
        object [] children = new object[acc.accChildCount];
        int obtained;

        // Fill in our allocated array with children        
        AccessibleChildren(acc, 0, acc.accChildCount, 
          children, out obtained);
    
        // Print out the children to prove that this worked
        Console.WriteLine("obtained = " + obtained);
        foreach (object o in children)
          Console.WriteLine(o);
      }
    }
    catch (Exception ex)
    {
      Console.WriteLine("Error: " + ex.ToString());
    }
  }
}