' To compile:
' vbc Listing18_11vb.vb /r:Accessibility.dll

Imports System
Imports System.Text
Imports System.Runtime.InteropServices
Imports Accessibility

Structure POINT
  Public x As Integer
  Public y As Integer
End Structure

Module ArrayExample
   
  ' Must use DllImport for the next two methods because Declare doesn't support setting PreserveSig to false

  <DllImport("oleacc.dll", PreserveSig:=False)> _
  Sub AccessibleChildren(paccContainer As IAccessible, iChildStart As Integer, cChildren As Integer, <Out> rgvarChildren() As Object, ByRef pcObtained As Integer)
  End Sub   
   
  <DllImport("oleacc.dll", PreserveSig:=False)> _
  Sub AccessibleObjectFromPoint(ptScreen As POINT, ByRef ppacc As IAccessible, <MarshalAs(UnmanagedType.Struct)> ByRef pvarChild As Object)
  End Sub   
 
  Declare Function GetCursorPos Lib "user32.dll" (ByRef lpPoint As POINT) As Boolean

  Public Sub Main()
    Dim acc As IAccessible = Nothing
    Dim p As POINT
    Dim var As Object
      
    Try
      If GetCursorPos(p) Then
        ' Try to get an accessible object under the cursor
        AccessibleObjectFromPoint(p, acc, var)
            
        Dim children(acc.accChildCount) As Object
        Dim obtained As Integer
            
        ' Fill in our allocated array with children        
        AccessibleChildren(acc, 0, acc.accChildCount, children, obtained)
            
        ' Print out the children to prove that this worked
        Console.WriteLine(("obtained = " & obtained))
        Dim o As Object
        For Each o In children
           Console.WriteLine(o)
        Next o
      End If
    Catch ex As Exception
      Console.WriteLine("Error: " & ex.ToString())
    End Try
  End Sub
End Module