// To compile:
// csc Listing18_2.cs

using System;
using System.Runtime.InteropServices;

public class SimpleTiming
{
  // PInvoke signatures:
  [DllImport("kernel32.dll")]
  static extern bool QueryPerformanceCounter(out long lpPerformanceCount);

  [DllImport("kernel32.dll")]
  static extern bool QueryPerformanceFrequency(out long lpFrequency);

  public static void Main()
  {
    long timeBefore, timeAfter, frequency;
    double timeDiff;
    int i;

    if (!QueryPerformanceFrequency(out frequency))
    {
      Console.WriteLine("Computer doesn't support performance counters");
      return;
    }

    QueryPerformanceCounter(out timeBefore);
    for (i = 1; i <= 100000000; i++)
    {
      Math.Sqrt(100);
    }
    QueryPerformanceCounter(out timeAfter);

    timeDiff = (timeAfter - timeBefore) / (double)frequency;

    Console.WriteLine("Time to calculate square root 100,000,000 times: "
      + timeDiff + " seconds");
  }
}