// To compile:
// csc Listing18_6cs.cs
//
// To run, this requires the appropriate sample.ini file in the root of the C drive.

using System;
using System.Runtime.InteropServices;

public class UsingIntPtr
{
  [DllImport("kernel32.dll")]
  static extern int GetPrivateProfileSectionNames(IntPtr lpszReturnBuffer,
    int nSize, string lpFileName);

  public static void Main()
  {
    IntPtr ptr = IntPtr.Zero;
    string s;

    try
    {
      // Allocate a buffer in unmanaged memory
      ptr = Marshal.AllocHGlobal(1024);

      int numChars = GetPrivateProfileSectionNames(ptr, 1024, "c:\\sample.ini");

      // Convert the entire written part of the unmanaged buffer to a string
      s = Marshal.PtrToStringAnsi(ptr, numChars-1);
    }
    finally
    {
      // Free the original unmanaged buffer
      if (ptr != IntPtr.Zero) Marshal.FreeHGlobal(ptr);
    }

    // Split the string into an array of strings, using null as the delimiter
    string [] sections = s.Split('\0');

    foreach (string section in sections)
    {
      Console.WriteLine("Section: " + section);
    }
  }
}