' To compile:
' vbc Listing18_6vb.vb
'
' To run, this requires the appropriate sample.ini file in the root of the C drive.

Imports System
Imports System.Runtime.InteropServices
Imports Microsoft.VisualBasic

Public Module UsingIntPtr
   
  Declare Ansi Function GetPrivateProfileSectionNamesA Lib "kernel32.dll" _
  (lpszReturnBuffer As IntPtr, nSize As Integer, lpFileName As String) As Integer
   
  Public Sub Main()
    Dim ptr As IntPtr = IntPtr.Zero
    Dim s As String
      
    Try
      ' Allocate a buffer in unmanaged memory
      ptr = Marshal.AllocHGlobal(1024)
         
      Dim numChars As Integer = GetPrivateProfileSectionNamesA(ptr, 1024, "c:\sample.ini")
         
      ' Convert the entire written part of the unmanaged buffer to a string
      s = Marshal.PtrToStringAnsi(ptr, numChars-1)
    Finally
      ' Free the original unmanaged buffer
      If Not ptr.Equals(IntPtr.Zero) Then
        Marshal.FreeHGlobal(ptr)
      End If
    End Try 
      ' Split the string into an array of strings, using null as the delimiter
      Dim sections As String() = s.Split(ControlChars.NullChar)
      
      Dim section As String
      For Each section In sections
        Console.WriteLine("Section: " & section)
      Next section
   End Sub
End Module