// To compile:
// csc Listing18_7cs.cs /r:Accessibility.dll

using System;
using System.Text;
using System.Runtime.InteropServices;
using Accessibility;

struct POINT
{ 
  public int x;
  public int y;
}

public class ArrayExample
{
  [DllImport("oleacc.dll")]
  static extern uint AccessibleChildren(IAccessible paccContainer, 
    int iChildStart, int cChildren, [Out] object [] rgvarChildren, 
    out int pcObtained);

  [DllImport("oleacc.dll")]
  static extern uint AccessibleObjectFromPoint(POINT ptScreen, 
    out IAccessible ppacc, 
    [MarshalAs(UnmanagedType.Struct)] out object pvarChild);

  [DllImport("user32.dll")]
  static extern bool GetCursorPos(out POINT lpPoint);

  public static void Main()
  {
    IAccessible acc = null;
    POINT p;
    Object var;
    
    if (GetCursorPos(out p))
    {
      // Try to get an accessible object under the cursor
      uint hresult = AccessibleObjectFromPoint(p, out acc, out var);

      if (hresult >= 0)
      {
        object [] children = new object[acc.accChildCount];
        int obtained;

        // Fill in our allocated array with children        
        hresult = AccessibleChildren(acc, 0, acc.accChildCount, children, 
          out obtained);
  
        if (hresult >= 0)
        {
          // Print out the children to prove that this worked
          Console.WriteLine("obtained = " + obtained);
          foreach (object o in children)
            Console.WriteLine(o);
        }
      }
    }
  }
}