' To compile:
' vbc Listing18_7vb.vb /r:Accessibility.dll

Imports System
Imports System.Text
Imports System.Runtime.InteropServices
Imports Accessibility

Structure POINT
  Public x As Integer
  Public y As Integer
End Structure

Module ArrayExample
   
  Declare Function AccessibleChildren Lib "oleacc.dll" _
  (paccContainer As IAccessible, iChildStart As Integer, cChildren As Integer, <Out> rgvarChildren() As Object, ByRef pcObtained As Integer) As Integer
   
  Declare Function AccessibleObjectFromPoint Lib "oleacc.dll" _
  (ptScreen As POINT, ByRef ppacc As IAccessible, <MarshalAs(UnmanagedType.Struct)> ByRef pvarChild As Object) As Integer
   
  Declare Function GetCursorPos Lib "user32.dll" (ByRef lpPoint As POINT) As Boolean
   
  Public Sub Main()
    Dim acc As IAccessible = Nothing
    Dim p As POINT
    Dim var As Object
      
    If GetCursorPos(p) Then
      ' Try to get an accessible object under the cursor
      Dim hresult As Integer = AccessibleObjectFromPoint(p, acc, var)
         
      If hresult >= 0 Then
        Dim children(acc.accChildCount) As Object
        Dim obtained As Integer
            
        ' Fill in our allocated array with children        
        hresult = AccessibleChildren(acc, 0, acc.accChildCount, children, obtained)
            
        If hresult >= 0 Then
          ' Print out the children to prove that this worked
          Console.WriteLine("obtained = " & obtained)
          Dim o As Object
          For Each o In children
            Console.WriteLine(o)
          Next o
        End If
      End If
    End If
  End Sub
End Module