using System;
using System.Text;
using System.Runtime.InteropServices;

public class ErrorHelper
{
  const uint FORMAT_MESSAGE_FROM_SYSTEM = 0x1000;
  const ushort LANG_NEUTRAL = 0x0;
  const ushort SUBLANG_DEFAULT = 0x1;

  [DllImport("kernel32.dll", CharSet=CharSet.Auto)]
  static extern uint FormatMessage(uint dwFlags, IntPtr lpSource, 
    int dwMessageId, int dwLanguageId, [Out] StringBuilder lpBuffer, 
    int nSize, IntPtr Arguments);

  static int MakeLangId(ushort p, ushort s) { return (s << 10) | p; }

  public static string GetErrorMessage(int errorCode)
  {
    StringBuilder sb = new StringBuilder(1024);

    if (FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, IntPtr.Zero, errorCode,
      MakeLangId(LANG_NEUTRAL, SUBLANG_DEFAULT), sb, sb.Capacity, 
      IntPtr.Zero) != 0)
    {
      return sb.ToString();
    }
    else
    {
      return "<Unrecognized error>";
    }
  }
}