// To compile:
// csc Listing19_12cs.cs

using System;
using System.Reflection;
using System.Reflection.Emit;
using System.Runtime.InteropServices;
 
public class DynamicBeeper
{
  public static void Main()
  {
    DynamicPInvoke("user32.dll", "MessageBeep", typeof(bool), 
      new Type[]{ typeof(uint) }, new Object[]{ (uint)0 });
  }

  public static object DynamicPInvoke(string dll, string entryPoint, 
    Type returnType, Type [] parameterTypes, object [] parameterValues)
  {
    // Create a dynamic assembly and a dynamic module
    AssemblyName asmName = new AssemblyName();
    asmName.Name = "tempAssembly";
    AssemblyBuilder dynamicAsm = 
      AppDomain.CurrentDomain.DefineDynamicAssembly(asmName, 
      AssemblyBuilderAccess.Run);
    ModuleBuilder dynamicMod = 
      dynamicAsm.DefineDynamicModule("tempModule");

    // Dynamically construct a global PInvoke signature 
    // using the input information
    MethodBuilder dynamicMethod = dynamicMod.DefinePInvokeMethod(
      entryPoint, dll, MethodAttributes.Static | MethodAttributes.Public
      | MethodAttributes.PinvokeImpl, CallingConventions.Standard,
      returnType, parameterTypes, CallingConvention.Winapi, 
      CharSet.Ansi);

    // This global method is now complete
    dynamicMod.CreateGlobalFunctions();

    // Get a MethodInfo for the PInvoke method
    MethodInfo mi = dynamicMod.GetMethod(entryPoint);

    // Invoke the static method and return whatever it returns
    return mi.Invoke(null, parameterValues);
  }
}