' To compile:
' vbc Listing19_12vb.vb

Imports System
Imports System.Reflection
Imports System.Reflection.Emit
Imports System.Runtime.InteropServices

Public Class DynamicBeeper
 
  Public Shared Sub Main()
    DynamicPInvoke("user32.dll", "MessageBeep", GetType(Boolean), _
      New Type() {GetType(Integer)}, New Object() {CType(0, Integer)})
  End Sub
   
  Public Shared Function DynamicPInvoke(dll As String, entryPoint As String, returnType As Type, _
    parameterTypes() As Type, parameterValues() As Object) As Object

    ' Create a dynamic assembly and a dynamic module
    Dim asmName As New AssemblyName()
    asmName.Name = "tempAssembly"
    Dim dynamicAsm As AssemblyBuilder = AppDomain.CurrentDomain.DefineDynamicAssembly(asmName, AssemblyBuilderAccess.Run)
    Dim dynamicMod As ModuleBuilder = dynamicAsm.DefineDynamicModule("tempModule")
      
    ' Dynamically construct a global PInvoke signature 
    ' using the input information
    Dim dynamicMethod As MethodBuilder = dynamicMod.DefinePInvokeMethod(entryPoint, dll, _
      MethodAttributes.Static Or MethodAttributes.Public Or MethodAttributes.PinvokeImpl, _
      CallingConventions.Standard, returnType, parameterTypes, CallingConvention.Winapi, CharSet.Ansi)
      
    ' This global method is now complete
    dynamicMod.CreateGlobalFunctions()
      
    ' Get a MethodInfo for the PInvoke method
    Dim mi As MethodInfo = dynamicMod.GetMethod(entryPoint)
      
    ' Invoke the static method and return whatever it returns
    DynamicPInvoke = mi.Invoke(Nothing, parameterValues)
  End Function

End Class