' To compile:
' vbc Listing19_13vb.vb

Imports System
Imports System.Runtime.InteropServices

Structure COORD
  Friend X As Short
  Friend Y As Short
End Structure

<StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Unicode)> _
Structure KEY_EVENT_RECORD
  Friend bKeyDown As Boolean
  Friend wRepeatCount As Short
  Friend wVirtualKeyCode As Short
  Friend wVirtualScanCode As Short
  Friend UnicodeChar As Char
  Friend dwControlKeyState As Integer
End Structure

Structure MOUSE_EVENT_RECORD
  Friend dwMousePosition As COORD
  Friend dwButtonState As Integer
  Friend dwControlKeyState As Integer
  Friend dwEventFlags As Integer
End Structure

Structure WINDOW_BUFFER_SIZE_RECORD
  Friend dwSize As COORD
End Structure

Structure MENU_EVENT_RECORD
  Friend dwCommandId As Integer
End Structure

Structure FOCUS_EVENT_RECORD
  Friend bSetFocus As Boolean
End Structure

Structure INPUT_RECORD
  Friend EventType As EventTypes
  Friend KeyEvent As KEY_EVENT_RECORD
  Friend MouseEvent As MOUSE_EVENT_RECORD
  Friend WindowBufferSizeEvent As WINDOW_BUFFER_SIZE_RECORD
  Friend MenuEvent As MENU_EVENT_RECORD
  Friend FocusEvent As FOCUS_EVENT_RECORD
End Structure

Enum EventTypes As Short
  KEY_EVENT                = &H01 
  MOUSE_EVENT              = &H02
  WINDOW_BUFFER_SIZE_EVENT = &H04 
  MENU_EVENT               = &H08 
  FOCUS_EVENT              = &H10 
End Enum

' Constants used with PInvoke methods
Class Constants
  ' Standard input, output, and error
  Friend Const STD_INPUT_HANDLE As Integer = -10
  Friend Const STD_OUTPUT_HANDLE As Integer = -11
  Friend Const STD_ERROR_HANDLE As Integer = -12
      
  ' Returned by GetStdHandle when an error occurs
  Friend Shared ReadOnly INVALID_HANDLE_VALUE As New IntPtr(-1)
End Class

Public Class Echo
      
  Private Declare Function GetStdHandle Lib "kernel32.dll" (nStdHandle As Integer) As IntPtr

  Private Declare Ansi Function ReadConsoleInput Lib "kernel32.dll" Alias "ReadConsoleInputA" _
    (hConsoleInput As IntPtr, <Out> lpBuffer() As INPUT_RECORD, nLength As Integer, _
    ByRef lpNumberOfEventsRead As Integer) As Boolean

  Public Shared Sub Main()
    Dim stdin As IntPtr = GetStdHandle(Constants.STD_INPUT_HANDLE)
         
    If stdin.Equals(Constants.INVALID_HANDLE_VALUE) Then
      Throw New Exception("Unable to get standard input handle")
    End If 

    Dim records(0) As INPUT_RECORD
    Dim eventsRead As Integer = 0
         
    ' Loop forever
    While True
      If ReadConsoleInput(stdin, records, records.Length, eventsRead) Then
        If records(0).EventType = EventTypes.KEY_EVENT And records(0).KeyEvent.bKeyDown Then
          Console.WriteLine("You pressed '" & records(0).KeyEvent.UnicodeChar & "' (" & records(0).KeyEvent.wVirtualKeyCode & ")!")
        End If
      End If
    End While
  End Sub
End Class