' To compile:
' vbc /t:library Listing19_15vb.vb

Imports System
Imports System.Runtime.InteropServices

Structure MULTI_QI
  Friend pIID As IntPtr
  <MarshalAs(UnmanagedType.IUnknown)> Friend pItf As Object
  Friend hr As Integer
End Structure

<StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Unicode)> _
Friend Structure COSERVERINFO
  Friend dwReserved1 As Integer
  Friend pwszName As String
  Friend pAuthInfo As IntPtr
  Friend dwReserved2 As Integer
End Structure

Public Class ComHelpers
  Private Const CLSCTX_REMOTE_SERVER As Integer = &H10
  Private Shared IID_IUnknown As New Guid("00000000-0000-0000-C000-000000000046")
 
  <DllImport("ole32.dll", CharSet:=CharSet.Unicode, PreserveSig:=False)> _
  Private Shared Sub CLSIDFromProgIDEx(lpszProgID As String, ByRef pclsid As Guid)
  End Sub

  <DllImport("ole32.dll", PreserveSig:=False)> _
  Private Shared Sub CoCreateInstanceEx( _
    <MarshalAs(UnmanagedType.LPStruct)> rclsid As Guid, _
    <MarshalAs(UnmanagedType.IUnknown)> punkOuter As Object, _
    dwClsCtx As Integer, <[In]> ByRef pServerInfo As COSERVERINFO, _
    cmq As Integer, <[In], Out> pResults() As MULTI_QI)
  End Sub
   
  Public Shared Function CreateRemoteInstance(progId As String, serverName As String) As Object
    ' Specify just the server name in the COSERVERINFO structure
    Dim csi As New COSERVERINFO()
    csi.pwszName = serverName
    csi.pAuthInfo = IntPtr.Zero
    csi.dwReserved1 = 0
    csi.dwReserved2 = 0
      
    ' Find the CLSID for the input ProgID
    Dim clsid As Guid
    CLSIDFromProgIDEx(progId, clsid)
      
    ' Query for only one interface (IUnknown)
    Dim mqi(0) As MULTI_QI
    mqi(0) = New MULTI_QI()
      
    Dim handle As New GCHandle()
    Try
      ' Pin the Guid representing IID_IUnknown
      handle = GCHandle.Alloc(IID_IUnknown, GCHandleType.Pinned)
         
      ' Set the field to the address of the Guid instance
      mqi(0).pIID = handle.AddrOfPinnedObject()
         
      ' Make the PInvoke call
      CoCreateInstanceEx(clsid, Nothing, CLSCTX_REMOTE_SERVER, csi, 1, mqi)
    Finally
      If handle.IsAllocated Then handle.Free()
    End Try 

    ' Return the RCW
    CreateRemoteInstance = mqi(0).pItf
  End Function
End Class