' To compile:
' vbc Listing19_1vb.vb ErrorHelper.vb

Imports System
Imports System.Runtime.InteropServices

Public Class CopyFile
  Private Shared CALLBACK_CHUNK_FINISHED As Integer = 0
  Private Shared CALLBACK_STREAM_SWITCH As Integer = 1
  Private Shared PROGRESS_CONTINUE As Integer = 0

  Delegate Function CopyProgressDelegate(TotalFileSize As Long, TotalBytesTransferred As Long, StreamSize As Long, StreamBytesTransferred As Long, dwStreamNumber As Integer, dwCallbackReason As Integer, hSourceFile As IntPtr, hDestinationFile As IntPtr, lpData As IntPtr) As Integer

  Declare Auto Function CopyFileEx Lib "kernel32.dll" (lpExistingFileName As String, lpNewFileName As String, lpProgressRoutine As CopyProgressDelegate, lpData As IntPtr, <[In]> ByRef pbCancel As Boolean, dwCopyFlags As Integer) As Boolean
   
  Private Shared d As CopyProgressDelegate
   
  Public Shared Sub Main()
    Dim cancel As Boolean = False
    d = AddressOf OnProgress
      
    Console.WriteLine("Copy file...")
    Dim result As Boolean
    result = CopyFileEx("c:\file1.txt", "c:\file2.txt", d, IntPtr.Zero, cancel, 0)
      
    If Not result Then
      Dim errorCode As Integer = Marshal.GetLastWin32Error()
      Dim message As String = ErrorHelper.GetErrorMessage(errorCode)
         
      If message = "" Then
        Console.WriteLine("Failed with error code " & errorCode)
      Else
        Console.WriteLine("Failed: " & message)
      End If
    Else
      Console.WriteLine("...Finished")
    End If
  End Sub
   
  ' Callback method
  Shared Function OnProgress(TotalFileSize As Long, TotalBytesTransferred As Long, StreamSize As Long, StreamBytesTransferred As Long, dwStreamNumber As Integer, dwCallbackReason As Integer, hSourceFile As IntPtr, hDestinationFile As IntPtr, lpData As IntPtr) As Integer
    If dwCallbackReason = CALLBACK_CHUNK_FINISHED Then
      Console.WriteLine("************* Chunk Finished *************")
      Console.WriteLine("File Bytes:   " & TotalBytesTransferred & " of " & TotalFileSize)
      Console.WriteLine("Stream Bytes: " & StreamBytesTransferred & " of " & StreamSize)
    ElseIf dwCallbackReason = CALLBACK_STREAM_SWITCH Then
      Console.WriteLine("*************** New Stream ***************")
    Else
      Console.WriteLine("************ Unknown Callback ************")
    End If
    OnProgress = PROGRESS_CONTINUE
  End Function

End Class