' To compile:
' vbc Listing19_2vb.vb

Imports System

Public Enum ControlSignals
  CTRL_C_EVENT        = 0
  CTRL_BREAK_EVENT    = 1
  CTRL_CLOSE_EVENT    = 2
  CTRL_LOGOFF_EVENT   = 5
  CTRL_SHUTDOWN_EVENT = 6
End Enum

Class HandlesControlSignals

  Declare Function SetConsoleCtrlHandler Lib "kernel32.dll" _
    (ByVal HandlerRoutine As ConsoleCtrlDelegate, ByVal Add As Boolean) _
    As Boolean

  Delegate Function ConsoleCtrlDelegate( _
    ByVal dwControlType As ControlSignals) As Boolean

  Shared d As ConsoleCtrlDelegate

  Public Shared Sub Main()
    ' Required to prevent early collection of delegate
    d = AddressOf OnSignal

    ' Add our OnSignal method to the list of handlers
    SetConsoleCtrlHandler(d, True)

    Console.WriteLine("Press 'Q' (followed by Enter) to quit.")
    While (Console.ReadLine() <> "Q")
    End While

    ' Restore normal processing
    SetConsoleCtrlHandler(Nothing, False)
  End Sub

  Public Shared Function OnSignal( _
    ByVal dwControlType As ControlSignals) As Boolean
    Select Case dwControlType
      Case ControlSignals.CTRL_C_EVENT:
        Console.WriteLine("[Ctrl+C]  Press 'Q' to quit.")
        OnSignal = True
      Case ControlSignals.CTRL_BREAK_EVENT:
        Console.WriteLine("[Ctrl+Break]  Press 'Q' to quit.")
        OnSignal = True
      Case ControlSignals.CTRL_CLOSE_EVENT:
        Console.WriteLine("[Window Close]  Press 'Q' to quit.")
        OnSignal = True
      Case Else
        OnSignal = False
    End Select
  End Function
End Class