// To compile:
// csc Listing19_5cs.cs

using System;
using System.Runtime.InteropServices;

[StructLayout(LayoutKind.Sequential, CharSet=CharSet.Auto)]
internal struct OSVERSIONINFO_1
{
  internal int dwOSVersionInfoSize; 
  internal int dwMajorVersion; 
  internal int dwMinorVersion; 
  internal int dwBuildNumber; 
  internal int dwPlatformId; 
  [MarshalAs(UnmanagedType.ByValTStr, SizeConst=128)]
  internal string szCSDVersion; 
}

[StructLayout(LayoutKind.Sequential, CharSet=CharSet.Auto)]
internal struct OSVERSIONINFO_2
{
  internal int dwOSVersionInfoSize; 
  internal int dwMajorVersion; 
  internal int dwMinorVersion; 
  internal int dwBuildNumber; 
  internal int dwPlatformId; 
  [MarshalAs(UnmanagedType.ByValArray, SizeConst=128)] 
  internal char [] szCSDVersion; 
}

class GetWindowsVersion
{
  [DllImport("kernel32.dll", CharSet=CharSet.Auto)]
  static extern bool GetVersionEx(ref OSVERSIONINFO_1 lpVersionInfo);

  [DllImport("kernel32.dll", CharSet=CharSet.Auto)]
  static extern bool GetVersionEx(ref OSVERSIONINFO_2 lpVersionInfo);

  public static void Main()
  {
    OSVERSIONINFO_1 os1 = new OSVERSIONINFO_1();
    os1.dwOSVersionInfoSize = Marshal.SizeOf(os1);
    os1.szCSDVersion = new String(' ', 128);

    if (GetVersionEx(ref os1))
    {
      Console.WriteLine("String returned: '" + os1.szCSDVersion + "'");
    }

    OSVERSIONINFO_2 os2 = new OSVERSIONINFO_2();
    os2.dwOSVersionInfoSize = Marshal.SizeOf(os2);
    os2.szCSDVersion = new char[128];

    if (GetVersionEx(ref os2))
    {
      string desiredString = new String(os2.szCSDVersion).Trim('\0');
      Console.WriteLine("String returned: '" + desiredString + "'");
    }
  }
}