// To compile:
// csc /t:library Listing19_7cs.cs

using System;
using System.Runtime.InteropServices;

public class MarshaledStructInspector
{
  public static void DisplayStruct(object o)
  {
    int totalBytes = Marshal.SizeOf(o);
    Console.WriteLine("Total Bytes = " + totalBytes);

    IntPtr ptr = IntPtr.Zero;
    try
    {
      // Allocate unmanaged memory
      ptr = Marshal.AllocCoTaskMem(totalBytes);
      // Marshal the type to its unmanaged representation
      Marshal.StructureToPtr(o, ptr, false);

      byte [] bytes = new byte[4];

      for (int i = 0; i < totalBytes; i += 4)
      {
        // Print each byte in hexadecimal format
        for (int j = 0; j < 4; j++)
        {
          if (i + j < totalBytes)
          {
            bytes[j] = Marshal.ReadByte(ptr, i+j);
            Console.Write("{0:X2} ", bytes[j]);
          }
          else
          {
            Console.Write("   ");
          }
        }
        Console.Write("  ");

        // Print each byte as if it's a character
        for (int j = 0; j < 4 && i + j < totalBytes; j++)
        {
          if (bytes[j] == 0)
            Console.Write(".");
          else
            Console.Write(Convert.ToChar(bytes[j]));
        }
        Console.WriteLine("");
      }
    }
    finally
    {
      // Free the unmanaged memory
      if (ptr != IntPtr.Zero) Marshal.FreeCoTaskMem(ptr);
    }
  }
}