' To compile:
' vbc /t:library Listing19_7vb.vb

Imports System
Imports System.Runtime.InteropServices

Public Class MarshaledStructInspector
   
  Public Shared Sub DisplayStruct(o As Object)

    Dim totalBytes As Integer = Marshal.SizeOf(o)
    Console.WriteLine("Total Bytes = " & totalBytes)
      
    Dim ptr As IntPtr = IntPtr.Zero
    Try
      ' Allocate unmanaged memory
      ptr = Marshal.AllocCoTaskMem(totalBytes)
      
      ' Marshal the type to its unmanaged representation
      Marshal.StructureToPtr(o, ptr, False)
         
      Dim bytes(3) As Byte
         
      Dim i, j As Integer
      For i = 0 To totalBytes - 4 Step 4

        ' Print each byte in hexadecimal format
        For j = 0 To 3
          If i + j < totalBytes Then
            bytes(j) = Marshal.ReadByte(ptr, i+j)
            Console.Write("{0:X2} ", bytes(j))
          Else
            Console.Write("   ")
          End If
        Next j
        Console.Write("  ")
            
        ' Print each byte as if it's a character
        For j = 0 To 3
          If i + j < totalBytes Then
            If bytes(j) = 0 Then
              Console.Write(".")
            Else
              Console.Write(Convert.ToChar(bytes(j)))
            End If
          End If
        Next j
        
        Console.WriteLine("")
      Next i

      Finally
        ' Free the unmanaged memory
        If Not ptr.Equals(IntPtr.Zero) Then
          Marshal.FreeCoTaskMem(ptr)
        End If
      End Try
   End Sub

End Class