// To compile:
// csc /unsafe Listing19_9.cs

// Before running, copy sample.ini to the root of the C drive.

using System;
using System.Runtime.InteropServices;

public unsafe class UsingUnsafeCode
{
  [DllImport("kernel32.dll")]
  static extern int GetPrivateProfileSectionNamesW(char* lpszReturnBuffer,
    int nSize, char* lpFileName);

  public static void Main()
  {
    char* ptr = null;
    int numChars = 0;
    string s;

    try
    {
      // Allocate a buffer in unmanaged memory
      ptr = (char*)Marshal.AllocHGlobal(1024);

      fixed (char* iniFile = "c:\\sample.ini")
      {
        numChars = GetPrivateProfileSectionNamesW(ptr, 1024, iniFile);
      }
      // Convert the relevant part of the unmanaged buffer to a string
      s = new String(ptr, 0, numChars-1);
    }
    finally
    {
      // Free the original unmanaged buffer
      if (ptr != null) Marshal.FreeHGlobal((IntPtr)ptr);
    }

    // Split the string into an array of strings,
    // using null as the delimiter
    string [] sections = s.Split('\0');

    foreach (string section in sections)
    {
      Console.WriteLine("Section: " + section);
    }
  }
}