// To compile:
// csc /t:library IFont.cs

using System;
using System.Runtime.InteropServices;

[
  ComImport, 
  Guid("BEF6E002-A874-101A-8BBA-00AA00300CAB"), 
  InterfaceType(ComInterfaceType.InterfaceIsIUnknown) 
]
public interface IFont
{
  string Name { get; set; }
  long Size { get; set; }
  bool Bold { [return:MarshalAs(UnmanagedType.Bool)] get; [param:MarshalAs(UnmanagedType.Bool)] set; }
  bool Italic { [return:MarshalAs(UnmanagedType.Bool)] get; [param:MarshalAs(UnmanagedType.Bool)] set; }
  bool Underline { [return:MarshalAs(UnmanagedType.Bool)] get; [param:MarshalAs(UnmanagedType.Bool)] set; }
  bool Strikethrough { [return:MarshalAs(UnmanagedType.Bool)] get; [param:MarshalAs(UnmanagedType.Bool)] set; }
  short Weight { get; set; }
  short Charset { get; set; }
  IntPtr hFont { get; }
  void Clone([MarshalAs(UnmanagedType.LPArray)] out IFont ppfont);
  [PreserveSig]
  int IsEqual(IFont pfontOther);
  void SetRatio(int cyLogical, int cyHimetric);
  void QueryTextMetrics(IntPtr pTM);
  void AddRefHfont(IntPtr hFont);
  void ReleaseHfont(IntPtr hFont);
  void SetHdc(IntPtr hDC);
}
