' To compile, first compile IFont.cs.  Then run:
' vbc /t:library /out:ManagedForm.dll ManagedForm.vb FontMarshaler.vb /r:System.Windows.Forms.dll /r:System.dll /r:System.Drawing.dll /r:IFont.dll

Imports System
Imports System.Drawing
Imports System.Windows.Forms
Imports System.Runtime.InteropServices

Public Class ManagedForm
  Inherits Form

  Friend WithEvents TextBox1 As TextBox
  Friend WithEvents Button1 As Button
  Friend WithEvents FontDialog1 As FontDialog
  'Required by the Windows Form Designer
  Private components As System.ComponentModel.IContainer

  Public Sub New()
    MyBase.New()
    ' This call is required by the Windows Form Designer
    InitializeComponent()
  End Sub

  ' Form overrides Dispose to clean up the component list
  Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
    If disposing Then
      If Not (components Is Nothing) Then
        components.Dispose()
      End If
    End If
    MyBase.Dispose(disposing)
  End Sub

  ' Property that uses the custom marshaler
  Public Property TextBoxFont() As _
    <MarshalAs(UnmanagedType.CustomMarshaler, _
    MarshalTypeRef:=GetType(FontMarshaler))> Font
    Get
      TextBoxFont = TextBox1.Font
    End Get
    Set(<MarshalAs(UnmanagedType.CustomMarshaler, _
      MarshalTypeRef:=GetType(FontMarshaler))> ByVal Value As Font)
      TextBox1.Font = Value
    End Set
  End Property

  Private Sub Button1_Click(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) Handles Button1.Click
    FontDialog1.Font = TextBox1.Font
    FontDialog1.ShowDialog()
    TextBox1.Font = FontDialog1.Font
  End Sub

  ' The following procedure is required by the Windows Form Designer
  Private Sub InitializeComponent()
    Me.TextBox1 = New System.Windows.Forms.TextBox()
    Me.Button1 = New System.Windows.Forms.Button()
    Me.FontDialog1 = New System.Windows.Forms.FontDialog()
    Me.SuspendLayout()

    Me.TextBox1.Anchor = (((System.Windows.Forms.AnchorStyles.Top _
      Or System.Windows.Forms.AnchorStyles.Bottom) _
      Or System.Windows.Forms.AnchorStyles.Left) _
      Or System.Windows.Forms.AnchorStyles.Right)
    Me.TextBox1.Multiline = True
    Me.TextBox1.Name = "TextBox1"
    Me.TextBox1.Size = New System.Drawing.Size(392, 144)
    Me.TextBox1.Text = ""

    Me.Button1.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom _
      Or System.Windows.Forms.AnchorStyles.Left) _
      Or System.Windows.Forms.AnchorStyles.Right)
    Me.Button1.Location = New System.Drawing.Point(8, 152)
    Me.Button1.Name = "Button1"
    Me.Button1.Size = New System.Drawing.Size(376, 24)
    Me.Button1.Text = "Change Font"

    Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
    Me.ClientSize = New System.Drawing.Size(388, 181)
    Me.Controls.AddRange(New System.Windows.Forms.Control() _
      {Me.Button1, Me.TextBox1})
    Me.Name = "ManagedForm"
    Me.Text = "Visual Basic .NET Form"
    Me.ResumeLayout(False)
  End Sub
End Class