// This cannot be compiled as-is, but serves as a template for 
// custom marshalers written with Visual C++ .NET

#using <mscorlib.dll>

using namespace System;
using namespace System::Runtime::InteropServices;

public __gc class TypicalCustomMarshaler : public ICustomMarshaler
{
private:
  static TypicalCustomMarshaler *marshaler = NULL;

public:
  Object* MarshalNativeToManaged(IntPtr pNativeData)
  {
    if (pNativeData == IntPtr::Zero) return NULL;
    return new CustomRCW(
      static_cast<UnmanagedType*>(pNativeData.ToPointer()));
  };

  IntPtr MarshalManagedToNative(Object* ManagedObj)
  {
    if (ManagedObj == NULL) return IntPtr::Zero;
    CustomCCW *ccw = new CustomCCW(static_cast<ManagedType*>(ManagedObj));
    UnmanagedType* intf = NULL;
    ccw->QueryInterface(IID_UnmanagedType, (void**)&intf);
    return (IntPtr)intf;
  };

  void CleanUpNativeData(IntPtr pNativeData)
  {
    Marshal::Release(pNativeData);
  };

  void CleanUpManagedData(Object* ManagedObj)
  {
    // Nothing to do
  };

  int GetNativeDataSize()
  {
    return -1;
  };

  static ICustomMarshaler* GetInstance(String* cookie)
  {
    // Always return the same instance
    if (marshaler != NULL) marshaler = new TypicalCustomMarshaler();
    return marshaler;
  };
};