// To compile:
// csc /t:library Listing21_16cs.cs

using System.Runtime.InteropServices;

[
  ComImport,
  Guid("3050f2e3-98b5-11cf-bb82-00aa00bdce0b"),
  InterfaceType(ComInterfaceType.InterfaceIsDual),
  TypeLibType(TypeLibTypeFlags.FDual | TypeLibTypeFlags.FDispatchable)
]
interface IHTMLStyleSheet
{
  [DispId(DispIds.IHTMLSTYLESHEET_TITLE)]
  string title { set; get; }
  [DispId(DispIds.IHTMLSTYLESHEET_PARENTSTYLESHEET)]
  IHTMLStyleSheet parentStyleSheet { get; }
  [DispId(DispIds.IHTMLSTYLESHEET_OWNINGELEMENT)]
  IHTMLElement owningElement { get; }
  [DispId(DispIds.IHTMLSTYLESHEET_DISABLED)]
  bool disabled { set; get; }
  [DispId(DispIds.IHTMLSTYLESHEET_READONLY)]
  bool readOnly { get; }
  [DispId(DispIds.IHTMLSTYLESHEET_IMPORTS)] 
  IHTMLStyleSheetsCollection imports { get; }
  [DispId(DispIds.IHTMLSTYLESHEET_HREF)]
  string href { set; get; }
  [DispId(DispIds.IHTMLSTYLESHEET_TYPE)]
  string type { get; }
  [DispId(DispIds.IHTMLSTYLESHEET_ID)]
  string id { get; }
  [DispId(DispIds.IHTMLSTYLESHEET_ADDIMPORT)] 
  int addImport(string bstrURL, /*defaultvalue(-1)*/ int lIndex);
  [DispId(DispIds.IHTMLSTYLESHEET_ADDRULE)] 
  int addRule(string bstrSelector, string bstrStyle,
    /*defaultvalue(-1)*/ int lIndex);
  [DispId(DispIds.IHTMLSTYLESHEET_REMOVEIMPORT)]
  void removeImport(int lIndex);
  [DispId(DispIds.IHTMLSTYLESHEET_REMOVERULE)]
  void removeRule(int lIndex);
  [DispId(DispIds.IHTMLSTYLESHEET_MEDIA)]
  string media { set; get; }
  [DispId(DispIds.IHTMLSTYLESHEET_CSSTEXT)]
  string cssText { set; get; }
  [DispId(DispIds.IHTMLSTYLESHEET_RULES)]
  IHTMLStyleSheetRulesCollection rules { get; }
}

class DispIds
{
  public const int IHTMLSTYLESHEET_TITLE = 1001;
  public const int IHTMLSTYLESHEET_PARENTSTYLESHEET = 1002;
  public const int IHTMLSTYLESHEET_OWNINGELEMENT = 1003;
  public const int IHTMLSTYLESHEET_DISABLED = unchecked((int)2147549260);
  public const int IHTMLSTYLESHEET_READONLY = 1004;
  public const int IHTMLSTYLESHEET_IMPORTS = 1005;
  public const int IHTMLSTYLESHEET_HREF = 1006;
  public const int IHTMLSTYLESHEET_TYPE = 1007;
  public const int IHTMLSTYLESHEET_ID = 1008;
  public const int IHTMLSTYLESHEET_ADDIMPORT = 1009;
  public const int IHTMLSTYLESHEET_ADDRULE = 1010;
  public const int IHTMLSTYLESHEET_REMOVEIMPORT = 1011;
  public const int IHTMLSTYLESHEET_REMOVERULE = 1012;
  public const int IHTMLSTYLESHEET_MEDIA = 1013;
  public const int IHTMLSTYLESHEET_CSSTEXT = 1014;
  public const int IHTMLSTYLESHEET_RULES = 1015;
  public const int IHTMLSTYLESHEET2_PAGES = 1016;
  public const int IHTMLSTYLESHEET2_ADDPAGERULE = 1017;
}

// [ ... ]
interface IHTMLElement
{
  //...
}

// [ ... ]
interface IHTMLStyleSheetsCollection
{
  //...
}

// [ ... ]
interface IHTMLStyleSheetRulesCollection
{
  //...
}