' To compile:
' vbc /t:library Listing21_18vb.vb

Imports System
Imports System.Runtime.InteropServices

< _
  ComImport, _
  Guid("D3984C13-C3CB-48E2-8BE5-5168340B4F35"), _
  InterfaceType(ComInterfaceType.InterfaceIsIUnknown) _
> _
Interface IWMPEffects
  Sub Render(ByRef levels As TimedLevel, hdc As IntPtr, ByRef r As RECT)
  Sub MediaInfo(channelCount As Integer, sampleRate As Integer, title As String)
  ReadOnly Property Capabilities As VisualizationCapabilities
  ReadOnly Property Title As String
  Function GetPresetTitle(preset As Integer) As String
  ReadOnly Property PresetCount As Integer
  Sub set_CurrentPreset(preset As Integer)
  Function get_CurrentPreset() As Integer
  Sub DisplayPropertyPage(hwndOwner As Integer)
  Sub GoFullScreen( _
    <MarshalAs(UnmanagedType.Bool)> startFullScreen As Boolean)
  Sub RenderFullScreen(ByRef levels As TimedLevel)
End Interface

' A visualization's capabilities
<ComVisible(False), Flags> _
Public Enum VisualizationCapabilities
  None = 0
  CanGoFullScreen = 1
  HasPropertyPage = 2
  VariableFrequencyStep = 4
End Enum

' The structure holding the frequency, waveform and 
' state data crucial for rendering
<ComVisible(False), StructLayout(LayoutKind.Sequential, Pack:=4)> _
Public Structure TimedLevel
  Public Const MaxSamples As Integer = 1024

  <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2*MaxSamples)> _
  Public frequency() As Byte

  <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2*MaxSamples)> _
  Public waveform() As Byte

  Public State As AudioState
  Public TimeStamp As Long
End Structure

' A standard Windows rectangle
<ComVisible(False), StructLayout(LayoutKind.Sequential, Pack:=4)> _
Public Structure RECT
  Public Left As Integer
  Public Top As Integer
  Public Right As Integer
  Public Bottom As Integer
End Structure

' The state of the audio
<ComVisible(False)> _
Public Enum AudioState
  Stopped = 0
  Paused = 1
  Playing = 2
End Enum