' To compile:
' vbc /t:library Listing21_19.vb

Imports System.Runtime.InteropServices

' The coclass interface
< _
  ComImport, _
  Guid("3050f58d-98b5-11cf-bb82-00aa00bdce0b"), _
  CoClass(GetType(HTMLStyleSheetClass)) _
> _
Interface HTMLStyleSheet
  Inherits DispHTMLStyleSheet
End Interface

' The default interface
'
' Since this is a dispinterface, we don't have 
' to worry about member layout.
< _
  ComImport, _
  Guid("3050f58d-98b5-11cf-bb82-00aa00bdce0b"), _
  InterfaceType(ComInterfaceType.InterfaceIsIDispatch), _
  TypeLibType(TypeLibTypeFlags.FHidden Or TypeLibTypeFlags.FDispatchable) _
> _
Interface DispHTMLStyleSheet
  <DispId(DispIds.IHTMLSTYLESHEET_TITLE)> _
  Property title As String

  <DispId(DispIds.IHTMLSTYLESHEET_PARENTSTYLESHEET)> _
  ReadOnly Property parentStyleSheet As IHTMLStyleSheet

  <DispId(DispIds.IHTMLSTYLESHEET_OWNINGELEMENT)> _
  ReadOnly Property owningElement As IHTMLElement

  <DispId(DispIds.IHTMLSTYLESHEET_DISABLED)> _
  Property disabled As Boolean

  <DispId(DispIds.IHTMLSTYLESHEET_READONLY)> _
  ReadOnly Property [readOnly] As Boolean

  <DispId(DispIds.IHTMLSTYLESHEET_IMPORTS)> _
  ReadOnly Property [imports] As IHTMLStyleSheetsCollection

  <DispId(DispIds.IHTMLSTYLESHEET_HREF)> _
  Property href As String

  <DispId(DispIds.IHTMLSTYLESHEET_TYPE)> _
  ReadOnly Property type As String

  <DispId(DispIds.IHTMLSTYLESHEET_ID)> _
  ReadOnly Property id As String

  <DispId(DispIds.IHTMLSTYLESHEET_ADDIMPORT)> _
  Function addImport(bstrURL As String, Optional lIndex As Integer = -1) _
    As Integer

  <DispId(DispIds.IHTMLSTYLESHEET_ADDRULE)> _
  Function addRule(bstrSelector As String, bstrStyle As String, _
    Optional lIndex As Integer = -1) As Integer

  <DispId(DispIds.IHTMLSTYLESHEET_REMOVEIMPORT)> _
  Sub removeImport(lIndex As Integer)

  <DispId(DispIds.IHTMLSTYLESHEET_REMOVERULE)> _
  Sub removeRule(lIndex As Integer)

  <DispId(DispIds.IHTMLSTYLESHEET_MEDIA)> _
  Property media As String

  <DispId(DispIds.IHTMLSTYLESHEET_CSSTEXT)> _
  Property cssText As String

  <DispId(DispIds.IHTMLSTYLESHEET_RULES)> _
  ReadOnly Property rules As IHTMLStyleSheetRulesCollection

  <DispId(DispIds.IHTMLSTYLESHEET2_PAGES)> _
  ReadOnly Property pages As IHTMLStyleSheetPagesCollection

  <DispId(DispIds.IHTMLSTYLESHEET2_ADDPAGERULE)> _
  Function addPageRule(bstrSelector As String, bstrStyle As String, _
    Optional lIndex As Integer = -1) As Integer
End Interface

Class DispIds
  Public Const IHTMLSTYLESHEET_TITLE = 1001
  Public Const IHTMLSTYLESHEET_PARENTSTYLESHEET = 1002
  Public Const IHTMLSTYLESHEET_OWNINGELEMENT = 1003
  Public Const IHTMLSTYLESHEET_DISABLED = &H8001004C
  Public Const IHTMLSTYLESHEET_READONLY = 1004
  Public Const IHTMLSTYLESHEET_IMPORTS = 1005
  Public Const IHTMLSTYLESHEET_HREF = 1006
  Public Const IHTMLSTYLESHEET_TYPE = 1007
  Public Const IHTMLSTYLESHEET_ID = 1008
  Public Const IHTMLSTYLESHEET_ADDIMPORT = 1009
  Public Const IHTMLSTYLESHEET_ADDRULE = 1010
  Public Const IHTMLSTYLESHEET_REMOVEIMPORT = 1011
  Public Const IHTMLSTYLESHEET_REMOVERULE = 1012
  Public Const IHTMLSTYLESHEET_MEDIA = 1013
  Public Const IHTMLSTYLESHEET_CSSTEXT = 1014
  Public Const IHTMLSTYLESHEET_RULES = 1015
  Public Const IHTMLSTYLESHEET2_PAGES = 1016
  Public Const IHTMLSTYLESHEET2_ADDPAGERULE = 1017
End Class

' < ... > _
Interface IHTMLElement
  '...
End Interface

' < ... > _
Interface IHTMLStyleSheet
  '...
End Interface

' < ... > _
Interface IHTMLStyleSheetsCollection
  '...
End Interface

' < ... > _
Interface IHTMLStyleSheetRulesCollection
  '...
End Interface

' < ... > _
Interface IHTMLStyleSheetPagesCollection
  '...
End Interface

' It's not possible to define the appropriate coclass in VB .NET, so
' this is just a placeholder.
Class HTMLStyleSheetClass
  '...
End Class