' To compile:
' vbc /t:library Listing21_2vb.vb

Imports System
Imports System.Runtime.InteropServices

< _
  ComImport, _
  Guid("D3984C13-C3CB-48E2-8BE5-5168340B4F35"), _
  InterfaceType(ComInterfaceType.InterfaceIsIUnknown) _
> _
Interface IWMPEffects
  Sub Render(<[In]> ByRef pLevels As TimedLevel, hdc As IntPtr, <[In]> ByRef prc As RECT)
  Sub MediaInfo(lChannelCount As Integer, lSampleRate As Integer, bstrTitle As String)
  Sub GetCapabilities(<Out> ByRef pdwCapabilities As VisualizationCapabilities)
  Sub GetTitle(<Out> ByRef bstrTitle As String)
  Sub GetPresetTitle(nPreset As Integer, <Out> ByRef bstrPresetTitle As String)
  Sub GetPresetCount(<Out> ByRef pnPresetCount As Integer)
  Sub SetCurrentPreset(nPreset As Integer)
  Sub GetCurrentPreset(<Out> ByRef pnPreset As Integer)
  Sub DisplayPropertyPage(hwndOwner As IntPtr)
  Sub GoFullscreen(<MarshalAs(UnmanagedType.Bool)> fFullScreen As Boolean)
  Sub RenderFullScreen(<[In]> ByRef pLevels As TimedLevel)
End Interface

' A visualization's capabilities
<ComVisible(False), Flags> _
Public Enum VisualizationCapabilities
  None = 0
  CanGoFullScreen = 1
  HasPropertyPage = 2
  VariableFrequencyStep = 4
End Enum

' The structure holding the frequency, waveform and 
' state data crucial for rendering
<ComVisible(False), StructLayout(LayoutKind.Sequential, Pack:=4)> _
Public Structure TimedLevel
  Public Const MaxSamples As Integer = 1024

  <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2*MaxSamples)> _
  Public frequency() As Byte

  <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2*MaxSamples)> _
  Public waveform() As Byte

  Public State As AudioState
  Public TimeStamp As Long
End Structure

' A standard Windows rectangle
<ComVisible(False), StructLayout(LayoutKind.Sequential, Pack:=4)> _
Public Structure RECT
  Public Left As Integer
  Public Top As Integer
  Public Right As Integer
  Public Bottom As Integer
End Structure

' The state of the audio
<ComVisible(False)> _
Public Enum AudioState
  Stopped = 0
  Paused = 1
  Playing = 2
End Enum