' To compile:
' vbc /t:library Listing21_5.vb

Imports System
Imports System.Runtime.InteropServices
Imports System.Runtime.CompilerServices

< _
  ComImport, _
  Guid("D3984C13-C3CB-48E2-8BE5-5168340B4F35"), _
  InterfaceType(ComInterfaceType.InterfaceIsIUnknown) _
> _
Interface IWMPEffects

  <MethodImpl(MethodImplOptions.InternalCall, _
    MethodCodeType:=MethodCodeType.Runtime)> _
  Sub Render(<[In]> ByRef pLevels As TimedLevel, <[In]> hdc As IntPtr, _
    <[In]> ByRef prc As RECT)

  <MethodImpl(MethodImplOptions.InternalCall, _
    MethodCodeType:=MethodCodeType.Runtime)> _
  Sub MediaInfo(<[In]> lChannelCount As Integer, <[In]> lSampleRate As _
    Integer, <[In], MarshalAs(UnmanagedType.BStr)> bstrTitle As String)
 
  <MethodImpl(MethodImplOptions.InternalCall, _
    MethodCodeType:=MethodCodeType.Runtime)> _
  Sub GetCapabilities(<Out> ByRef pdwCapabilities _
    As VisualizationCapabilities)

  <MethodImpl(MethodImplOptions.InternalCall, _
    MethodCodeType:=MethodCodeType.Runtime)> _
  Sub GetTitle(<Out, MarshalAs(UnmanagedType.BStr)> _
    ByRef bstrTitle As String)

  <MethodImpl(MethodImplOptions.InternalCall, _
    MethodCodeType:=MethodCodeType.Runtime)> _
  Sub GetPresetTitle(<[In]> nPreset As Integer, _
    <Out, MarshalAs(UnmanagedType.BStr)> bstrPresetTitle As String)

  <MethodImpl(MethodImplOptions.InternalCall, _
    MethodCodeType:=MethodCodeType.Runtime)> _
  Sub GetPresetCount(<Out> ByRef pnPresetCount As Integer)

  <MethodImpl(MethodImplOptions.InternalCall, _
    MethodCodeType:=MethodCodeType.Runtime)> _
  Sub SetCurrentPreset(<[In]> nPreset As Integer)

  <MethodImpl(MethodImplOptions.InternalCall, _
    MethodCodeType:=MethodCodeType.Runtime)> _
  Sub GetCurrentPreset(<Out> ByRef pnPreset As Integer)

  <MethodImpl(MethodImplOptions.InternalCall, _
    MethodCodeType:=MethodCodeType.Runtime)> _
  Sub DisplayPropertyPage(<[In]> hwndOwner As IntPtr)

  <MethodImpl(MethodImplOptions.InternalCall, _
    MethodCodeType:=MethodCodeType.Runtime)> _
  Sub GoFullScreen(<[In], MarshalAs(UnmanagedType.Bool)> _
    fFullScreen As Boolean)

  <MethodImpl(MethodImplOptions.InternalCall, _
    MethodCodeType:=MethodCodeType.Runtime)> _
  Sub RenderFullScreen(<[In]> ByRef pLevels As TimedLevel)

End Interface

' A visualization's capabilities
<ComVisible(False), Flags> _
Public Enum VisualizationCapabilities
  None = 0
  CanGoFullScreen = 1
  HasPropertyPage = 2
  VariableFrequencyStep = 4
End Enum

' The structure holding the frequency, waveform and 
' state data crucial for rendering
<ComVisible(False), StructLayout(LayoutKind.Sequential, Pack:=4)> _
Public Structure TimedLevel
  Public Const MaxSamples As Integer = 1024

  <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2*MaxSamples)> _
  Public frequency() As Byte

  <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2*MaxSamples)> _
  Public waveform() As Byte

  Public State As AudioState
  Public TimeStamp As Long
End Structure

' A standard Windows rectangle
<ComVisible(False), StructLayout(LayoutKind.Sequential, Pack:=4)> _
Public Structure RECT
  Public Left As Integer
  Public Top As Integer
  Public Right As Integer
  Public Bottom As Integer
End Structure

' The state of the audio
<ComVisible(False)> _
Public Enum AudioState
  Stopped = 0
  Paused = 1
  Playing = 2
End Enum