// To compile:
// csc Listing22_1cs.cs
// Then run "tlbexp Listing22_1cs.exe" so there's a type library to load.

using System;
using System.Runtime.InteropServices;

public class Listing22_1
{
  // Load a type library from a filename
  [DllImport("oleaut32.dll", CharSet=CharSet.Unicode, PreserveSig=false)]
  internal static extern UCOMITypeLib LoadTypeLibEx(string szFile, 
    REGKIND regkind);

  public static void Main()
  {
    UCOMITypeLib typeLib = LoadTypeLibEx("Listing22_1cs.tlb", REGKIND.REGKIND_NONE);
    TypeLibConverter converter = new TypeLibConverter();
    string name;
    string codebase;
    TYPELIBATTR attributes;
    IntPtr attributesPtr = IntPtr.Zero;

    try
    {
      typeLib.GetLibAttr(out attributesPtr);
      // Copy the data from the unmanaged structure to a new value type
      attributes = (TYPELIBATTR)Marshal.PtrToStructure(attributesPtr,
        typeof(TYPELIBATTR));
    }
    finally
    {
      // We must release the structure as documented by ITypeLib
      if (attributesPtr != IntPtr.Zero) typeLib.ReleaseTLibAttr(attributesPtr);
    }
    
    // Now that we have all the type library information, we can
    // call TypeLibConverter.GetPrimaryInteropAssembly
    converter.GetPrimaryInteropAssembly(attributes.guid, 
      attributes.wMajorVerNum, attributes.wMinorVerNum, attributes.lcid, 
      out name, out codebase);
  }
}

// REGKIND enumeration used by LoadTypeLibEx
internal enum REGKIND
{
  REGKIND_DEFAULT = 0,
  REGKIND_REGISTER = 1,
  REGKIND_NONE = 2
}