' To compile:
' vbc Listing22_1vb.vb
' Then run "tlbexp Listing22_1vb.exe" so there's a type library to load.

Imports System
Imports System.Runtime.InteropServices

Public Module Listing22_1

  ' Load a type library from a filename
  <DllImport("oleaut32.dll", CharSet:=CharSet.Unicode, PreserveSig:=False)> _
  Private Function LoadTypeLibEx(szFile As String, regkind As REGKIND) As UCOMITypeLib
  End Function

  Public Sub Main()
    Dim typeLib As UCOMITypeLib = LoadTypeLibEx("Listing22_1vb.tlb", REGKIND.REGKIND_NONE)
    Dim converter As New TypeLibConverter
    Dim name As String
    Dim codebase As String
    Dim attributes As TYPELIBATTR
    Dim attributesPtr As IntPtr = IntPtr.Zero

    Try
      typeLib.GetLibAttr(attributesPtr)
      ' Copy the data from the unmanaged structure to a new value type
      attributes = Marshal.PtrToStructure(attributesPtr, _
        GetType(TYPELIBATTR))
    Finally
      ' We must release the structure as documented by ITypeLib
      If (Not attributesPtr.Equals(IntPtr.Zero)) Then
        typeLib.ReleaseTLibAttr(attributesPtr)
      End If
    End Try
    
    ' Now that we have all the type library information, we can
    ' call TypeLibConverter.GetPrimaryInteropAssembly
    converter.GetPrimaryInteropAssembly(attributes.guid, _
      attributes.wMajorVerNum, attributes.wMinorVerNum, attributes.lcid, _
      name, codebase)
  End Sub

End Module

' REGKIND enumeration used by LoadTypeLibEx
Enum REGKIND
  REGKIND_DEFAULT = 0
  REGKIND_REGISTER = 1
  REGKIND_NONE = 2
End Enum