// To compile:
// csc Listing22_2cs.cs

using System;
using System.Runtime.InteropServices;
using System.Runtime.Remoting;

[Serializable]
public class MyImporter
{
  public void Import()
  {
    //...
  }

  //...

}

public class Listing22_2
{
  static void Main()
  {
    MyImporter importer = null;

    // Create a new AppDomain
    AppDomain domain = AppDomain.CreateDomain("MyImporterDomain");

    if (domain != null)
    {
      string asmFullName = typeof(MyImporter).Assembly.FullName;
      string typeFullName = typeof(MyImporter).FullName;

      // Create an instance of MyImporter in the separate AppDomain.
      // This is done instead of using "new MyImporter()" which would create
      // the type in the current AppDomain.
      ObjectHandle handle = domain.CreateInstance(asmFullName, typeFullName);

      if (handle != null)
      {
        // Unwrap the ObjectHandle so we can use the importer object
        importer = (MyImporter)handle.Unwrap();

        // Now call the method
        importer.Import();
      }

      // Unload the application domain
      AppDomain.Unload(domain);
    }
  }
}