' To compile:
' vbc Listing22_2vb.vb

Imports System
Imports System.Runtime.InteropServices
Imports System.Runtime.Remoting

<Serializable> _
Public Class MyImporter
  Public Sub Import()
    '...
  End Sub

  '...

End Class

Public Class Listing22_2

  Shared Sub Main()
    Dim importer As MyImporter = Nothing

    ' Create a new AppDomain
    Dim domain As AppDomain = AppDomain.CreateDomain("MyImporterDomain")

    If Not (domain Is Nothing) Then
      Dim asmFullName As String = GetType(MyImporter).Assembly.FullName
      Dim typeFullName As String = GetType(MyImporter).FullName
   
      ' Create an instance of MyImporter in the separate AppDomain.   
      ' This is done instead of using "new MyImporter()" which would create
      ' the type in the current AppDomain.
      Dim handle As ObjectHandle = domain.CreateInstance(asmFullName, typeFullName)
 
      If Not (handle Is Nothing) Then
        ' Unwrap the ObjectHandle so we can use the importer object
        importer = CType(handle.Unwrap(), MyImporter)
            
        ' Now call the method
        importer.Import()   
      End If
         
      ' Unload the application domain
      AppDomain.Unload(domain)
    End If
  End Sub

End Class