 using System.Runtime.InteropServices;

 namespace DirectX
 {
   // The DirectX7 class
   [ComImport, Guid("E1211353-8E94-11D1-8808-00C04FC2C602")]
   public class DirectX7 {}

   // Interfaces

   [
     ComImport,
     Guid("FAFA3599-8B72-11D2-90B2-00C04FC2C602"),
     InterfaceType(ComInterfaceType.InterfaceIsIUnknown)
   ]
   public interface IDirectX7
   {
     void slot1();
     DirectDraw7 DirectDrawCreate(string guid);
     void slot3();
     DirectSound DirectSoundCreate(string guid);
   }

   [
     ComImport,
     Guid("9F76FB00-8E92-11D1-8808-00C04FC2C602"),
     InterfaceType(ComInterfaceType.InterfaceIsIUnknown)
   ]
   public interface DirectSound
   {
     void slot1();
     void slot2();
     void slot3();
     DirectSoundBuffer CreateSoundBufferFromFile(string filename,
       ref DSBUFFERDESC bufferDesc, out WAVEFORMATEX format);
     void slot5();
     void slot6();
     void slot7();
     void SetCooperativeLevel(int hwnd, CONST_DSSCLFLAGS level);
   }

   [
     ComImport,
     Guid("9F76FB01-8E92-11D1-8808-00C04FC2C602"),
     InterfaceType(ComInterfaceType.InterfaceIsIUnknown)
   ]
   public interface DirectSoundBuffer
   {
     void slot1();
     void slot2();
     void slot3();
     void slot4();
     void slot5();
     void slot6();
     void slot7();
     void slot8();
     void slot9();
     void slot10();
     CONST_DSBSTATUSFLAGS GetStatus();
     void slot12();
     void slot13();
     void slot14();
     void Play(CONST_DSBPLAYFLAGS flags);
     void slot16();
     void slot17();
     void slot18();
     void slot19();
     void slot20();
     void slot21();
     void restore();
   }

   [
     ComImport,
     Guid("9F76FDE8-8E92-11D1-8808-00C04FC2C602"),
     InterfaceType(ComInterfaceType.InterfaceIsIUnknown)
   ]
   public interface DirectDrawSurface7
   {
     void slot1();
     void slot2();
     void slot3();
     int Blt(ref RECT destRect, DirectDrawSurface7 ddS,
       ref RECT srcRect, CONST_DDBLTFLAGS flags);
     void slot5();
     int BltFast(int dx, int dy, DirectDrawSurface7 ddS,
       ref RECT srcRect, CONST_DDBLTFASTFLAGS trans);
     void slot7();
     void slot8();
     void slot9();
     void slot10();
     void slot11();
     void slot12();
     void slot13();
     void slot14();
     void slot15();
     void slot16();
     void Flip(DirectDrawSurface7 ddS, CONST_DDFLIPFLAGS flags);
     DirectDrawSurface7 GetAttachedSurface(ref DDSCAPS2 caps);
     void slot19();
     void slot20();
     void GetCaps(ref DDSCAPS2 caps);
     void slot22();
     void GetColorKey( int flags, ref DDCOLORKEY val);
     void slot24();
     void slot25();
     void slot26();
     void slot27();
     void slot28();
     void slot29();
     void slot30();
     void slot31();
     void slot32();
     void slot33();
     void slot34();
     void slot35();
     void slot36();
     void GetPixelFormat(ref DDPIXELFORMAT pf);
     void slot38();
     void slot39();
     void slot40();
     void slot41();
     void slot42();
     void slot43();
     void slot44();
     void SetColorKey(CONST_DDCKEYFLAGS flags, ref DDCOLORKEY val);
   }

   [
     ComImport,
     Guid("9F76FDE7-8E92-11D1-8808-00C04FC2C602"),
     InterfaceType(ComInterfaceType.InterfaceIsIUnknown)
   ]
   public interface DirectDraw7
   {
     void slot1();
     void slot2();
     void slot3();
     void slot4();
     DirectDrawSurface7 CreateSurface(ref DDSURFACEDESC2 dd);
     DirectDrawSurface7 CreateSurfaceFromFile(
       string file, ref DDSURFACEDESC2 dd);
     void slot7();
     void slot8();
     void slot9();
     void slot10();
     void slot11();
     void slot12();
     void slot13();
     void slot14();
     void slot15();
     void slot16();
     void slot17();
     void slot18();
     void slot19();
     void slot20();
     void slot21();
     void slot22();
     void slot23();
     void slot24();
     void RestoreAllSurfaces();
     void slot26();
     void SetCooperativeLevel(int hdl, CONST_DDSCLFLAGS flags);
     void SetDisplayMode(int w, int h, int bpp, int iref, CONST_DDSDMFLAGS mode);
   }

   // Structs

   public struct RECT
   {
     public int Left;
     public int Top;
     public int Right;
     public int Bottom;

     public override string ToString()
     {
       return 
         "[" + Left + ", " + Top + "] - [" + Right + ", " + Bottom + "]";
     }
   }

   [StructLayout(LayoutKind.Sequential, Pack=4)]
   public struct DSBUFFERDESC
   {
     public int lSize;
     public CONST_DSBCAPSFLAGS lFlags;
     public int lBufferBytes;
     public int lReserved;
     public int lpwfxFormat;
   }

   [StructLayout(LayoutKind.Sequential, Pack=4)]
   public struct WAVEFORMATEX
   {
     public short nFormatTag;
     public short nChannels;
     public int lSamplesPerSec;
     public int lAvgBytesPerSec;
     public short nBlockAlign;
     public short nBitsPerSample;
     public short nSize;
     public int lExtra;
   }

   [StructLayout(LayoutKind.Sequential, Pack=4)]
   public struct DDSCAPS2
   {
     public CONST_DDSURFACECAPSFLAGS lCaps;
     public int lCaps2;
     public int lCaps3;
     public int lCaps4;
   }

   [StructLayout(LayoutKind.Sequential, Pack=4)]
   public struct DDSURFACEDESC2
   {
     public int lSize;
     public CONST_DDSURFACEDESCFLAGS lFlags;
     public int lHeight;
     public int lWidth;
     public int lPitch;
     public int lBackBufferCount;
     public int lZBufferBitDepth;
     public int lAlphaBitDepth;
     public int lReserved;
     public int lpSurface;
     public DDCOLORKEY ddckCKDestOverlay;
     public DDCOLORKEY ddckCKDestBlt;
     public DDCOLORKEY ddckCKSrcOverlay;
     public DDCOLORKEY ddckCKSrcBlt;
     public DDPIXELFORMAT ddpfPixelFormat;
     public DDSCAPS2 ddsCaps;
     public int lTextureStage;
     public int lLinearSize;
     public int lMipMapCount;
     public int lRefreshRate;
   }

   [StructLayout(LayoutKind.Sequential, Pack=4)]
   public struct DDCOLORKEY
   {
     public int low;
     public int high;
   }

   [StructLayout(LayoutKind.Sequential, Pack=4)]
   public struct DDPIXELFORMAT
   {
     public int lSize;
     public int lFlags;
     public int lFourCC;
     public int internalVal1;
     public int internalVal2;
     public int internalVal3;
     public int internalVal4;
     public int internalVal5;
     public int lRGBBitCount;
     public int lYUVBitCount;
     public int lZBufferBitDepth;
     public int lAlphaBitDepth;
     public int lLuminanceBitCount;
     public int lBumpBitCount;
     public int lRBitMask;
     public int lYBitMask;
     public int lStencilBitDepth;
     public int lLuminanceBitMask;
     public int lBumpDuBitMask;
     public int lGBitMask;
     public int lUBitMask;
     public int lZBitMask;
     public int lBumpDvBitMask;
     public int lBBitMask;
     public int lVBitMask;
     public int lStencilBitMask;
     public int lBumpLuminanceBitMask;
     public int lRGBAlphaBitMask;
     public int lYUVAlphaBitMask;
     public int lLuminanceAlphaBitMask;
     public int lRGBZBitMask;
     public int lYUVZBitMask;
   }

   // Enums

   public enum CONST_DDSDMFLAGS
   {
     DDSDM_DEFAULT         = 0,
     DDSDM_STANDARDVGAMODE = 1
   }

   public enum CONST_DDSCLFLAGS : uint
   {
     DDSCL_FULLSCREEN         = 0x1,
     DDSCL_ALLOWREBOOT        = 0x2,
     DDSCL_NOWINDOWCHANGES    = 0x4,
     DDSCL_NORMAL             = 0x8,
     DDSCL_EXCLUSIVE          = 0x10,
     DDSCL_ALLOWMODEX         = 0x40,
     DDSCL_SETFOCUSWINDOW     = 0x80,
     DDSCL_SETDEVICEWINDOW    = 0x100,
     DDSCL_CREATEDEVICEWINDOW = 0x200,
     DDSCL_MULTITHREADED      = 0x400
   }

   public enum CONST_DDSURFACEDESCFLAGS : uint
   {
     DDSD_CAPS            = 0x1,
     DDSD_HEIGHT          = 0x2,
     DDSD_WIDTH           = 0x4,
     DDSD_PITCH           = 0x8,
     DDSD_BACKBUFFERCOUNT = 0x20,
     DDSD_ZBUFFERBITDEPTH = 0x40,
     DDSD_ALPHABITDEPTH   = 0x80,
     DDSD_TEXTURESTAGE    = 0x100000,
     DDSD_LPSURFACE       = 0x800,
     DDSD_PIXELFORMAT     = 0x1000,
     DDSD_CKDESTOVERLAY   = 0x2000,
     DDSD_CKDESTBLT       = 0x4000,
     DDSD_CKSRCOVERLAY    = 0x8000,
     DDSD_CKSRCBLT        = 0x10000,
     DDSD_MIPMAPCOUNT     = 0x20000,
     DDSD_REFRESHRATE     = 0x40000,
     DDSD_LINEARSIZE      = 0x80000,
     DDSD_ALL             = 0xFF9EE
   }

   public enum CONST_DDSURFACECAPSFLAGS : uint
   {
     DDSCAPS_ALPHA              = 0x2,
     DDSCAPS_BACKBUFFER         = 0x4,
     DDSCAPS_COMPLEX            = 0x8,
     DDSCAPS_FLIP               = 0x10,
     DDSCAPS_FRONTBUFFER        = 0x20,
     DDSCAPS_OFFSCREENPLAIN     = 0x40,
     DDSCAPS_OVERLAY            = 0x80,
     DDSCAPS_PALETTE            = 0x100,
     DDSCAPS_PRIMARYSURFACE     = 0x200,
     DDSCAPS_PRIMARYSURFACELEFT = 0x400,
     DDSCAPS_SYSTEMMEMORY       = 0x800,
     DDSCAPS_TEXTURE            = 0x1000,
     DDSCAPS_3DDEVICE           = 0x2000,
     DDSCAPS_VIDEOMEMORY        = 0x4000,
     DDSCAPS_VISIBLE            = 0x8000,
     DDSCAPS_WRITEONLY          = 0x10000,
     DDSCAPS_ZBUFFER            = 0x20000,
     DDSCAPS_OWNDC              = 0x40000,
     DDSCAPS_LIVEVIDEO          = 0x80000,
     DDSCAPS_HWCODEC            = 0x100000,
     DDSCAPS_MODEX              = 0x200000,
     DDSCAPS_MIPMAP             = 0x400000,
     DDSCAPS_RESERVED2          = 0x800000,
     DDSCAPS_ALLOCONLOAD        = 0x4000000,
     DDSCAPS_VIDEOPORT          = 0x8000000,
     DDSCAPS_LOCALVIDMEM        = 0x10000000,
     DDSCAPS_NONLOCALVIDMEM     = 0x20000000,
     DDSCAPS_STANDARDVGAMODE    = 0x40000000,
     DDSCAPS_OPTIMIZED          = 0x80000000
   }

   public enum CONST_DDCKEYFLAGS : uint
   {
     DDCKEY_COLORSPACE  = 0x1,
     DDCKEY_DESTBLT     = 0x2,
     DDCKEY_DESTOVERLAY = 0x4,
     DDCKEY_SRCBLT      = 0x8,
     DDCKEY_SRCOVERLAY  = 0x10
   }

   public enum CONST_DDFLIPFLAGS : uint
   {
     DDFLIP_WAIT       = 0x1,
     DDFLIP_EVEN       = 0x2,
     DDFLIP_ODD        = 0x4,
     DDFLIP_NOVSYNC    = 0x8,
     DDFLIP_STEREO     = 0x10,
     DDFLIP_DONOTWAIT  = 0x20,
     DDFLIP_INTERFVAL2 = 0x20000000,
     DDFLIP_INTERFVAL3 = 0x30000000,
     DDFLIP_INTERFVAL4 = 0x40000000
   }

   public enum CONST_DDBLTFLAGS : uint
   {
     DDBLT_ASYNC           = 0x200,
     DDBLT_COLORFILL       = 0x400,
     DDBLT_DDFX            = 0x800,
     DDBLT_DDROPS          = 0x1000,
     DDBLT_KEYDEST         = 0x2000,
     DDBLT_KEYDESTOVERRIDE = 0x4000,
     DDBLT_KEYSRC          = 0x8000,
     DDBLT_KEYSRCOVERRIDE  = 0x10000,
     DDBLT_ROP             = 0x20000,
     DDBLT_ROTATIONANGLE   = 0x40000,
     DDBLT_WAIT            = 0x1000000,
     DDBLT_DEPTHFILL       = 0x2000000,
     DDBLT_DONOTWAIT       = 0x8000000,
   }

   public enum CONST_DDBLTFASTFLAGS : uint
   {
     DDBLTFAST_NOCOLORKEY   = 0x0,
     DDBLTFAST_SRCCOLORKEY  = 0x1,
     DDBLTFAST_DESTCOLORKEY = 0x2,
     DDBLTFAST_WAIT         = 0x10,
     DDBLTFAST_DONOTWAIT    = 0x20
   }

   public enum CONST_DSBCAPSFLAGS : uint
   {
     DSBCAPS_PRIMARYBUFFER       = 0x1,
     DSBCAPS_STATIC              = 0x2,
     DSBCAPS_LOCHARDWARE         = 0x4,
     DSBCAPS_LOCSOFTWARE         = 0x8,
     DSBCAPS_CTRL3D              = 0x10,
     DSBCAPS_CTRLFREQUENCY       = 0x20,
     DSBCAPS_CTRLPAN             = 0x40,
     DSBCAPS_CTRLVOLUME          = 0x80,
     DSBCAPS_CTRLPOSITIONNOTIFY  = 0x100,
     DSBCAPS_STICKYFOCUS         = 0x4000,
     DSBCAPS_GLOBALFOCUS         = 0x8000,
     DSBCAPS_GETCURRENTPOSITION2 = 0x10000,
     DSBCAPS_MUTE3DATMAXDISTANCE = 0x20000
   }

   public enum CONST_DSBPLAYFLAGS
   {
     DSBPLAY_DEFAULT = 0,
     DSBPLAY_LOOPING = 1
   }

   public enum CONST_DSBSTATUSFLAGS
   {
     DSBSTATUS_PLAYING    = 1,
     DSBSTATUS_BUFFERLOST = 2,
     DSBSTATUS_LOOPING    = 4
   }

   public enum CONST_DSSCLFLAGS
   {
     DSSCL_NORMAL       = 1,
     DSSCL_PRIORITY     = 2,
     DSSCL_EXCLUSIVE    = 3,
     DSSCL_WRITEPRIMARY = 4
   }
 }