public class GroundLayer : Layer
{
  // Creates the layer with the background picture
  // and initializes its characteristics.
  public GroundLayer(string bitmapFile, bool hasTransparentColor,
    int frequency) : base(bitmapFile, hasTransparentColor, frequency) {}

  // Draw the contents of the layer.
  // This must be followed by a call to Util.RenderComplete().
  public override void Render()
  {
    // Call the base method to draw the background picture
    base.Render();

    // If the background has moved, move the player along with it
    if (Util.IsTimeToMove(Frequency))
      Game.Player.LocationX--;

    // Render each envelope
    for (int i = 0; i < Game.GridWidth; i++)
    {
      for (int j = 0; j < Game.GridHeight; j++)
      {
        Game.EnvelopeGrid[i,j].Render();
      }
    }

    // Render the player
    Game.Player.Render();
  }
}