public class FrontLayer : Layer
{
  // Create a FrontLayer with the background in bitmapFile.
  // It will always have a transparent color and be stationary.
  public FrontLayer(string bitmapFile) : base(bitmapFile, true, 0) {}

  // Draw the contents the layer, including
  // bonuses, lives remaining, and the score.
  // This must be followed by a call to Util.RenderComplete().
  //
  public override void Render()
  {
    // Call the base method to draw the background picture
    base.Render();

    // Draw each bonus, starting at the top right corner of the screen
    for (int i = 1; i <= Game.NumBonuses; i++)
    {
      Game.BonusPicture.DrawAt(
        Screen.Width - (i * Game.BonusPicture.Width), 0);
    }

    // Draw each life remaining, 
    // starting at the top left corner of the screen
    for (int i = 1; i <= Game.NumLives; i++)
    {
      Game.PlayerPicture.DrawAt((i - 1) * Game.PlayerPicture.Width, 0);
    }

    // Draw the ScorePicture object.
    Game.ScorePicture.Draw(Game.Score);
  }
}