public class IntroScreen : Screen
{
  // Creates the screen with the background picture
  public IntroScreen(string bitmapFile) : base(bitmapFile) {}

  // Draws the contents of the screen
  public override void Render()
  {
    // Draw the background at the top left corner.
    // Don't call the base Render method since it calls
    // Util.RenderComplete().
    background.DrawAt(0, 0);

    // Draw the high score at the bottom of the screen
    Game.ScorePicture.SetPosition(190, 
      Screen.Height - Game.DigitPadding - Game.DigitHeight, true);
    Game.ScorePicture.Draw(Game.HighScore);

    // Draw the current score above the high score
    Game.ScorePicture.SetPosition(190, 
      Screen.Height - (Game.DigitPadding + Game.DigitHeight) * 2, true);
    Game.ScorePicture.Draw(Game.Score);

    // We're done rendering
    Util.RenderComplete();
  }
}