// This is to be compiled with a few other source files as follows:
//
// csc /t:library /out:BookExamples.WindowsMediaPlayer.dll IWMPEffects.cs SupportingTypes.cs Visualization.cs PresetEnumAttribute.cs /r:System.Drawing.dll /r:System.Windows.Forms.dll /r:System.dll

using System;

[AttributeUsage(AttributeTargets.Class)]
public class PresetEnumAttribute : Attribute
{
  private Type enumType;

  // Constructor - called when the attribute is applied
  public PresetEnumAttribute(Type zeroBasedEnumType)
  {
    enumType = zeroBasedEnumType;
  }

  // Read-only property to get the enum type
  public virtual Type EnumType
  {
    get { return enumType; }
  }
}