' To compile:
' vbc /t:library SimpleVisualization.vb /r:System.Drawing.dll /r:BookExamples.WindowsMediaPlayer.dll

Imports System.Drawing
Imports BookExamples.WindowsMediaPlayer

Public Class SimpleVisualization
  Inherits Visualization

  Public Overrides ReadOnly Property Title As String
    Get
      Title = "Simple"
    End Get
  End Property

  Public Overrides Sub Render(levels As TimedLevel, _
    g As Graphics, r As Rectangle)

    ' Fill background with dark blue
    g.FillRectangle(Brushes.DarkBlue, r)

    ' Walk through the frequencies until we run
    ' out of samples or drawing surface
    Dim x As Integer = r.Left
    While (x < r.Right AndAlso x < TimedLevel.MaxSamples)
      If (levels.GetFrequency(AudioChannel.Left, x) >= 128)
        g.DrawLine(Pens.Red, x, r.Top, x, r.Bottom)
      End If
      x = x + 1
    End While
  End Sub
End Class